////////////////////////////////////////////////////////////////////////
// epginfo.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.epginfo")

// <%pre>
#line 1 "epginfo.ecpp"


#include <stdext.h>
#include <exception.h>
#include <setup.h>
#include <tools.h>
#include <epg_events.h>
#include <recman.h>

#if VDRVERSNUM < 20301
namespace vdrlive {
	class SchedulesLock
	{
		public:
			SchedulesLock() : m_schedulesLock() {}

			operator cSchedulesLock& () { return m_schedulesLock; }

		private:
			SchedulesLock(SchedulesLock const &schedulesLock) {}

			cSchedulesLock m_schedulesLock;
	};

	typedef stdext::shared_ptr<SchedulesLock> SchedulesLockPtr;
}
#endif

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class epgTools_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epgTools_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    epgTools_type epgTools;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("epginfo");

static const char* rawData = "P\000\000\000\275\000\000\000\306\000\000\000\310\000\000\000\313\000\000\000\314\000\000"
  "\000\017\001\000\000\021\001\000\000\024\001\000\000\025\001\000\000,\001\000\000.\001\000\000/\001\000\0001\001\000"
  "\0002\001\000\000M\001\000\000N\001\000\000O\001\000\000Q\001\000\000R\001\000\000\n<html>\n\t<head>\n\t\t<meta name="
  "\"viewport\" content=\"width=device-width, initial-scale=1\" />\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n\t</head"
  ">\n\t<body onload=\"adjustHeader()\" onresize=\"adjustHeader()\">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\n\t\t"
  "\n\t\t</div>\n\t</body>\n</html>\n\n\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    epgTools(*this, "epgTools")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("epginfo " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string epgid = qparam.get< std::string >("epgid");
std::string async = qparam.get< std::string >("async");
std::string tab = qparam.get< std::string >("tab");
  // </%args>

#line 38 "epginfo.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 41 "epginfo.ecpp"
  typedef EpgInfoPtr epgEvent_type;
  TNT_REQUEST_SHARED_VAR(EpgInfoPtr, epgEvent, ());   // <%request> EpgInfoPtr epgEvent
  _tnt_ignore_unused<epgEvent_type>(epgEvent);
#line 42 "epginfo.ecpp"
  typedef std::string epgImage_type;
  TNT_REQUEST_SHARED_VAR(std::string, epgImage, ());   // <%request> std::string epgImage
  _tnt_ignore_unused<epgImage_type>(epgImage);
#line 43 "epginfo.ecpp"
  typedef uintptr_t i_event_type;
  TNT_REQUEST_SHARED_VAR(uintptr_t, i_event, ());   // <%request> uintptr_t i_event
  _tnt_ignore_unused<i_event_type>(i_event);
#line 44 "epginfo.ecpp"
  typedef uintptr_t irecording_type;
  TNT_REQUEST_SHARED_VAR(uintptr_t, irecording, ());   // <%request> uintptr_t irecording
  _tnt_ignore_unused<irecording_type>(irecording);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 48 "epginfo.ecpp"

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

	pageTitle = tr("Electronic program guide information");

	bool ajaxReq = !async.empty() && (lexical_cast<int>(async) != 0);

	bool aboutBox = false;

#if VDRVERSNUM >= 20301
	bool isEvent = false;
#else
	// One of these get initialized when needed. When freed by getting
	// out of scope they will release (if initialized) important
	// Semaphores/Locks.
	SchedulesLockPtr schedulesLockPtr;
#endif
	RecordingsManagerPtr recordings;
	epgImage.clear();
        i_event = 0;
        irecording = 0;

	if (!epgid.empty()) {

		const std::string recording_s("recording_");
		const std::string event_s("event_");
		const std::string aboutbox("aboutBox");

		// check for recording:
		if (epgid.compare(0, recording_s.length(), recording_s) == 0) {
			recordings = LiveRecordingsManager();
			const cRecording *recording = recordings->GetByMd5Hash(epgid);
			if (recording == 0) {
				throw HtmlError(tr("Couldn't find recording or no recordings available"));
			}
			epgEvent = EpgEvents::CreateEpgInfo(epgid, recording);
                        cTvMedia image;
			EpgEvents::PosterTvscraper(image, NULL, recording);
			epgImage = image.path;
                        irecording = (uintptr_t)recording;
		}
		// check for event:
		else if (epgid.compare(0, event_s.length(), event_s) == 0) {
#if VDRVERSNUM >= 20301
			/* Need to lock here channels also, because CreateEpgInfo will lock
			 * it also and this will result in a wrong lock order */
			LOCK_CHANNELS_READ;
			LOCK_SCHEDULES_READ;
			epgEvent = EpgEvents::CreateEpgInfo(epgid, Schedules);
			isEvent = true;
#else
			schedulesLockPtr = SchedulesLockPtr(new SchedulesLock);
			if (!schedulesLockPtr) {
				throw HtmlError(tr("Error aquiring schedules lock"));
			}
			const cSchedules* schedules = cSchedules::Schedules(*schedulesLockPtr);
			if (!schedules) {
				throw HtmlError(tr("Error aquiring schedules"));
			}
			epgEvent = EpgEvents::CreateEpgInfo(epgid, schedules);
#endif
			const cEvent* event = epgEvent->Event();
                        cTvMedia image;
			EpgEvents::PosterTvscraper(image, event, NULL);
			epgImage = image.path;
                        i_event = (uintptr_t)event;
		}
		// check for aboutbox:
		else if (epgid.compare(0, aboutbox.length(), aboutbox) == 0) {
			aboutBox = true;
		}
	}

  // <& pageelems.doc_type ...
  { 
#line 121 "epginfo.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 121 "epginfo.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n<html>\n\t<head>\n\t\t<meta name="viewport" content="width=device-width, initial-scale=1" />\n\t\t<title>VDR-Live - 
#line 125 "epginfo.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n
#line 126 "epginfo.ecpp"

	if (!ajaxReq) {

  reply.out() << _tntChunks[2]; // \t\t
  // <& pageelems.stylesheets ...
  { 
#line 129 "epginfo.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 129 "epginfo.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 130 "epginfo.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 130 "epginfo.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n
#line 131 "epginfo.ecpp"

	}

  reply.out() << _tntChunks[5]; // \t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()">\n
#line 136 "epginfo.ecpp"

	if (!ajaxReq) {

  reply.out() << _tntChunks[6]; // \t\t
  // <& pageelems.logo ...
  { 
#line 139 "epginfo.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 139 "epginfo.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n\t\t
  // <& menu ...
  { 
#line 140 "epginfo.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 140 "epginfo.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[8]; // \n
#line 141 "epginfo.ecpp"

	}

  reply.out() << _tntChunks[9]; // \t\t<div class="inhalt">\n
#line 145 "epginfo.ecpp"

	if (epgEvent) {
		std::string start(epgEvent->StartTime("%a,") + std::string(" ")
				+ epgEvent->StartTime(tr("%b %d %y")) + std::string(" ")
        + epgEvent->StartTime(tr("%I:%M %p")) );
    if (epgEvent->EventDuration() < 0) {  // epg event, no recording
      start += std::string(" - ") + epgEvent->EndTime(tr("%I:%M %p"));
    	start += " ";
			AppendDuration(start, tr("(%d:%02d)"), epgEvent->Duration()/60/60, epgEvent->Duration()/60 % 60);
    } else { // recording
    	start += ". ";
      start += tr("Recording length");
      start += ": ";
			AppendDuration(start, tr("%d:%02d"), epgEvent->Duration()/60/60, epgEvent->Duration()/60 % 60);
      start += ". ";
      start += tr("Event duration");
      start += ": ";
		  AppendDuration(start, tr("%d:%02d"), epgEvent->EventDuration()/60/60, epgEvent->EventDuration()/60 % 60);
    }

		std::string tools_component;
		if (recordings) {
			tools_component = epgEvent->Archived().empty() ? "recordings.rec_tools" : "recordings.archived_disc" ;
		}
#if VDRVERSNUM >= 20301
		if (isEvent)
#else
		if (schedulesLockPtr)
#endif
			tools_component = "epginfo.epgTools";


  reply.out() << _tntChunks[10]; // \t\t
  // <& pageelems.epg_tt_box ...
  { 
#line 177 "epginfo.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 177 "epginfo.ecpp"
    _tnt_cq5.add( "archived", (epgEvent->Archived()));
#line 177 "epginfo.ecpp"
    _tnt_cq5.add( "boxId", (epgEvent->Id()));
#line 177 "epginfo.ecpp"
    _tnt_cq5.add( "caption", (epgEvent->Caption()));
#line 177 "epginfo.ecpp"
    _tnt_cq5.add( "elapsed", (epgEvent->Elapsed()));
#line 177 "epginfo.ecpp"
    _tnt_cq5.add( "epgImage", (epgImage));
#line 177 "epginfo.ecpp"
    _tnt_cq5.add( "filename", (epgEvent->FileName()));
#line 177 "epginfo.ecpp"
    _tnt_cq5.add( "ievent", (i_event));
#line 177 "epginfo.ecpp"
    _tnt_cq5.add( "irecording", (irecording));
#line 177 "epginfo.ecpp"
    _tnt_cq5.add( "long_descr", (epgEvent->LongDescr()));
#line 177 "epginfo.ecpp"
    _tnt_cq5.add( "short_descr", (epgEvent->ShortDescr()));
#line 177 "epginfo.ecpp"
    _tnt_cq5.add( "time", (start));
#line 177 "epginfo.ecpp"
    _tnt_cq5.add( "title", (epgEvent->Title()));
#line 177 "epginfo.ecpp"
    _tnt_cq5.add( "tools_comp", (tools_component));
#line 177 "epginfo.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "epg_tt_box"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[11]; // \n
#line 178 "epginfo.ecpp"

	}
	if (aboutBox) {

  reply.out() << _tntChunks[12]; // \t\t
  // <& pageelems.about_tt_box ...
  { 
#line 182 "epginfo.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 182 "epginfo.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "about_tt_box"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[13]; // \n
#line 183 "epginfo.ecpp"

	}

  reply.out() << _tntChunks[14]; // \t\t</div>\n\t</body>\n</html>\n\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[15]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[16]; // \n
  reply.out() << _tntChunks[17]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epgTools_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("epginfo::epgTools " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string title = qparam.get< std::string >("title");
int detail = qparam.get< int >("detail");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 38 "epginfo.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 41 "epginfo.ecpp"
  typedef EpgInfoPtr epgEvent_type;
  TNT_REQUEST_SHARED_VAR(EpgInfoPtr, epgEvent, ());   // <%request> EpgInfoPtr epgEvent
  _tnt_ignore_unused<epgEvent_type>(epgEvent);
#line 42 "epginfo.ecpp"
  typedef std::string epgImage_type;
  TNT_REQUEST_SHARED_VAR(std::string, epgImage, ());   // <%request> std::string epgImage
  _tnt_ignore_unused<epgImage_type>(epgImage);
#line 43 "epginfo.ecpp"
  typedef uintptr_t i_event_type;
  TNT_REQUEST_SHARED_VAR(uintptr_t, i_event, ());   // <%request> uintptr_t i_event
  _tnt_ignore_unused<i_event_type>(i_event);
#line 44 "epginfo.ecpp"
  typedef uintptr_t irecording_type;
  TNT_REQUEST_SHARED_VAR(uintptr_t, irecording, ());   // <%request> uintptr_t irecording
  _tnt_ignore_unused<irecording_type>(irecording);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& pageelems.epg_tool_box ...
  { 
#line 201 "epginfo.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 201 "epginfo.ecpp"
    _tnt_cq7.add( "detail", (detail));
#line 201 "epginfo.ecpp"
    _tnt_cq7.add( "endTime", (epgEvent->GetEndTime()));
#line 201 "epginfo.ecpp"
    _tnt_cq7.add( "epgid", (id));
#line 201 "epginfo.ecpp"
    _tnt_cq7.add( "s_IMDB_ID", (s_IMDB_ID));
#line 201 "epginfo.ecpp"
    _tnt_cq7.add( "startTime", (epgEvent->GetStartTime()));
#line 201 "epginfo.ecpp"
    _tnt_cq7.add( "title", (title));
#line 201 "epginfo.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "epg_tool_box"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[18]; // \n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
