////////////////////////////////////////////////////////////////////////
// pageelems.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.pageelems")

// <%pre>
#line 1 "pageelems.ecpp"

#include "../services.h"

#include <livefeatures.h>
#include <setup.h>
#include <timers.h>
#include <tools.h>
#include <epg_events.h>
#include <gen_version_suffix.h>
#include <tntfeatures.h>

using namespace vdrlive;

std::string toString(const std::vector<std::string> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const std::string &str:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(str);
  }
  return result;
}
  
std::string toString(const std::vector<int> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const int &i:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(std::to_string(i) );
  }
  return result;
}
  
std::string toString(const std::vector<cActor> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const cActor &actor:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(actor.name);
    if (!actor.role.empty() ) {
      result.append(" as ");
      result.append(actor.role);
    }
  }
  return result;
}


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class doc_type_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        doc_type_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class create_html_js_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        create_html_js_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class stylesheets_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        stylesheets_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class logo_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        logo_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hide_element_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hide_element_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class progressbar_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        progressbar_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ajax_action_href_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_action_href_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class imdb_info_href_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        imdb_info_href_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hls_channel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hls_channel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class m3u_playlist_channel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_playlist_channel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class m3u_playlist_recording_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_playlist_recording_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class event_timer_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        event_timer_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_timer_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_timer_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ajax_js_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_js_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class infobox_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        infobox_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class epg_tool_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epg_tool_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class epg_tt_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epg_tt_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class media_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        media_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class about_tt_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        about_tt_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    doc_type_type doc_type;
    create_html_js_type create_html_js;
    stylesheets_type stylesheets;
    logo_type logo;
    hide_element_type hide_element;
    progressbar_type progressbar;
    ajax_action_href_type ajax_action_href;
    imdb_info_href_type imdb_info_href;
    hls_channel_type hls_channel;
    m3u_playlist_channel_type m3u_playlist_channel;
    m3u_playlist_recording_type m3u_playlist_recording;
    event_timer_type event_timer;
    edit_timer_type edit_timer;
    ajax_js_type ajax_js;
    infobox_type infobox;
    epg_tool_box_type epg_tool_box;
    epg_tt_box_type epg_tt_box;
    media_type media;
    about_tt_box_type about_tt_box;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("pageelems");

static const char* rawData = "\034\006\000\000\035\006\000\000\037\006\000\000\215\006\000\000\216\006\000\000\220\006"
  "\000\0001\007\000\000\314\010\000\000\354\010\000\000!\t\000\000-\t\000\0009\t\000\000\200\t\000\000\003\n\000\000s"
  "\013\000\000\204\013\000\000\220\013\000\000\351\014\000\000\362\014\000\000m\015\000\000v\015\000\000\220\015\000"
  "\000\370\015\000\000\001\016\000\000\n\016\000\000'\016\000\000V\017\000\000\330\017\000\000\357\017\000\000\327\022"
  "\000\000\333\022\000\0002\025\000\000\266\025\000\000\371\025\000\000\326\026\000\000\021\030\000\000\025\030\000\000"
  "d\032\000\000f\032\000\000\322\032\000\000\236\033\000\000\237\033\000\000\241\033\000\000h\034\000\000\202\034\000"
  "\000\213\034\000\000\230\034\000\000\302\034\000\000\351\034\000\000\352\034\000\000\354\034\000\000\006\035\000\000"
  "\007\035\000\000\t\035\000\000\025\035\000\000.\035\000\0002\035\000\0003\035\000\000A\035\000\000R\035\000\000S\035"
  "\000\000U\035\000\000X\035\000\000\134\035\000\000^\035\000\000q\035\000\000x\035\000\000z\035\000\000{\035\000\000"
  "\206\035\000\000\215\035\000\000\232\035\000\000\233\035\000\000\235\035\000\000\307\035\000\000\311\035\000\000\354"
  "\035\000\000\356\035\000\000\t\036\000\000\022\036\000\000\036\036\000\000\037\036\000\000!\036\000\000D\036\000\000P"
  "\036\000\000Y\036\000\000e\036\000\000f\036\000\000h\036\000\000\212\036\000\000\226\036\000\000\237\036\000\000\253"
  "\036\000\000\311\036\000\000\325\036\000\000\336\036\000\000\352\036\000\000\353\036\000\000\355\036\000\000\t\037"
  "\000\000\025\037\000\000\036\037\000\000&\037\000\000+\037\000\000,\037\000\000.\037\000\0000\037\000\0001\037\000"
  "\000R\037\000\000^\037\000\000g\037\000\000o\037\000\000p\037\000\000r\037\000\000\224\037\000\000\240\037\000\000"
  "\251\037\000\000\261\037\000\000\263\037\000\000\265\037\000\000\366!\000\000\t\"\000\000C\"\000\000M\"\000\000j\""
  "\000\000t\"\000\000\221\"\000\000q#\000\000\321#\000\000\322#\000\000\324#\000\000K$\000\000\204%\000\000\244%\000"
  "\000\000&\000\000\005&\000\000\n&\000\000\017&\000\000\024&\000\000I&\000\000N&\000\000v&\000\000\323&\000\000\375&"
  "\000\000\024'\000\000\025'\000\000\027'\000\000\030'\000\000\032'\000\000\033'\000\000D'\000\000P'\000\000Y'\000\000e"
  "'\000\000f'\000\000h'\000\000i'\000\000k'\000\000l'\000\000\210'\000\000\212'\000\000\244'\000\000\246'\000\000\274'"
  "\000\000\320'\000\000\372'\000\000\006(\000\000\017(\000\0000(\000\000D(\000\000F(\000\000N(\000\000b(\000\000d(\000"
  "\000l(\000\000\200(\000\000\203(\000\000\206(\000\000\207(\000\000\217(\000\000\220(\000\000\222(\000\000\264(\000"
  "\000\361(\000\000\027)\000\000K)\000\000P)\000\000^)\000\000\226)\000\000\232)\000\000\250)\000\000\337)\000\000\344)"
  "\000\000\362)\000\000**\000\000/*\000\000;*\000\000P*\000\000W*\000\000\301*\000\000\003+\000\000\026+\000\000\035+"
  "\000\000$+\000\000C+\000\000P+\000\000g+\000\000\205+\000\000\254+\000\000\313+\000\000\353+\000\000\010,\000\0006,"
  "\000\000Z,\000\000w,\000\000\243,\000\000\307,\000\000\346,\000\000\033-\000\000A-\000\000^-\000\000_-\000\000\215-"
  "\000\000\216-\000\000\262-\000\000\277-\000\000\313-\000\000\335-\000\000\363-\000\000\374-\000\000\003.\000\000\030."
  "\000\000\031.\000\000 .\000\0007.\000\0009.\000\000:.\000\000;.\000\000Y.\000\000\134.\000\000c.\000\000|.\000\000}."
  "\000\000\200.\000\000\207.\000\000\236.\000\000\237.\000\000\246.\000\000\277.\000\000\306.\000\000\307.\000\000\340."
  "\000\000\343.\000\000\352.\000\000\003/\000\000\010/\000\000\017/\000\0009/\000\000L/\000\000R/\000\000g/\000\000o/"
  "\000\000v/\000\000\213/\000\000\222/\000\000\256/\000\000\267/\000\000\276/\000\000\335/\000\000\357/\000\000\372/"
  "\000\000\0170\000\000\0220\000\000.0\000\00050\000\000<0\000\000Q0\000\000V0\000\000]0\000\000r0\000\000s0\000\000v0"
  "\000\000}0\000\000~0\000\000\2230\000\000\2340\000\000\2430\000\000\3130\000\000\3360\000\000\3440\000\000\3450\000"
  "\000\3740\000\000\0051\000\000\0141\000\000#1\000\000+1\000\00021\000\00031\000\000J1\000\000K1\000\000R1\000\000i1"
  "\000\000p1\000\000w1\000\000\2161\000\000\2271\000\000\2361\000\000\2651\000\000\2761\000\000\3051\000\000\3061\000"
  "\000\3371\000\000\3441\000\000\3531\000\000\3621\000\000\3761\000\000\0172\000\000\0272\000\000\"2\000\000E2\000\000u"
  "2\000\000|2\000\000~2\000\000\2632\000\000\3112\000\000\3172\000\000\3322\000\000\3752\000\000-3\000\00043\000\00063"
  "\000\000k3\000\000\2013\000\000\2073\000\000\2313\000\000\2373\000\000\2503\000\000\2573\000\000\2733\000\000\3153"
  "\000\000\3163\000\000\3173\000\000\3273\000\000\3433\000\000\3573\000\000\0344\000\000\0354\000\000\0364\000\00044"
  "\000\000`4\000\000\2054\000\000\2074\000\000\0005\000\000g5\000\000\2265\000\000\3625\000\000W6\000\000\3606\000\000P"
  "7\000\000\2567\000\000\0218\000\000\2058\000\000\2648\000\000\3318\000\000\3748\000\000!9\000\000N9\000\000\2549\000"
  "\000\3129\000\000\3169\000\000\3249\000\000\3269\000\000\3279\000\000\3359\000\000\3379\000\000\3409\000\0005:\000"
  "\000\235:\000\000\273:\000\000\277:\000\000\305:\000\000\307:\000\000\310:\000\000\316:\000\000\320:\000\000\321:\000"
  "\000&;\000\000b;\000\000\024>\000\000C>\000\0003\?\000\000\n\n\n<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict/"
  "/EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n\n\n\n<script>\nfunction addErrorIcon(s, numErrors, dur"
  "ationDeviation) {\n  if (numErrors <= -100) return\n  s.a += '<div class=\"recording_errors\"><img class=\"icon\" src"
  "=\"'\n  if (durationDeviation > 300 || numErrors  > 0) s.a += 'RecordingErrors.png'\n  else if (durationDeviation > 1"
  "80) s.a += 'NotCheckedForRecordingErrors.png'\n  else {\n    if (numErrors == 0) s.a += 'NoRecordingErrors.png'\n    "
  "if (numErrors  > 0) s.a += 'RecordingErrors.png'\n    if (numErrors  < 0) s.a += 'NotCheckedForRecordingErrors.png'\n"
  "  }\n  s.a += '\" width = \"16px\" title=\"'\n  if (numErrors == 0) s.a += ''\n  if (numErrors  > 0) s.a += ' ' + Str"
  "ing(numErrors)\n  if (numErrors  < 0) s.a += ''\n  s.a += ''\n  s.a += ''\n  s.a += ': '\n  addTime(s, durationDeviat"
  "ion)\n  s.a += ' '\n  s.a += ''\n  s.a += '\" /> </div>'\n}\n\nfunction addHdSdIcon(s, hdsd, toolTip) {\n  s.a += '<d"
  "iv class=\"recording_sd_hd\"><img class=\"icon\" src=\"'\n  s.a += hdsd\n  s.a += 'd.png\" width = \"25px\" title=\"'"
  "\n  s.a += toolTip\n  s.a += '\" /></div>'\n}\n\nfunction IMDBS(s, im_db, name) {\n  if (im_db.length == 0) {\n    s."
  "a += '<a href=\"http://www.imdb.com/find\?s=all&q='\n    s.a += name\n  } else {\n    s.a += '<a href=\"https://www.i"
  "mdb.com/title/'\n    s.a += im_db\n  }\n  s.a += \n   '\" target=\"_blank\"><img class=\"icon\" src=\"imdb.png\" titl"
  "e=\"\"/></a>'\n}\n\n\nfunction addEvent(s, bottomrow_i, obj) {\n// first column, timer /red or green, ...\n  let bott"
  "omrow = ''\n  if (bottomrow_i != 0) bottomrow = 'bottomrow'\n  s.a += `<tr><td class=\"action leftcol ${bottomrow}\">"
  "`\n  if (obj[1].length != 0) {\n    s.a += '<a href=\"edit_timer.html\?timerid=timer_'\n    s.a += obj[1]\n    s.a +="
  " '\"><img class=\"icon\" src=\"\" title=\"\" />'\n  } else {\n    s.a += '<a href=\"edit_timer.html\?epgid=event_'\n "
  "   s.a += obj[0]\n    s.a += '\"><img class=\"icon\" src=\"\" title=\"\" />'\n  }\n  s.a += '</a>'\n  s.a += '<a href"
  "=\"searchresults.html\?searchplain='\n  s.a += obj[11]\n  s.a += '\"><img class=\"icon\" src=\"\" title=\"\"/></a>'\n"
  "  IMDBS(s, obj[14], obj[11])\n  s.a += '</td>'\n// second col, dependent on width: channel\n  if (obj[9] > 0) {\n    "
  "s.a += `<td class=\"td-hidden-xs ${bottomrow}\"><div class=\"hidden-xs withmargin\"><a href=\"schedule.html\?channel="
  "`\n    s.a += obj[9]\n    s.a += '\">'\n    s.a += obj[10]\n    s.a += '</a></div></td>'\n  }\n// third col: image\n "
  "   s.a += `<td class=\"enlarge-image ${bottomrow}\">`\n    addScraperImageTitle(s, obj[3], obj[4], obj[5], obj[6], ob"
  "j[7], obj[8], '');\n    s.a += '</td>'\n  s.a += `<td class=\"td-hidden-xs ${bottomrow}\"><div class=\"hidden-xs with"
  "margin\">`\n  s.a += obj[2]\n  s.a += '</div></td>'\n// col with times, channel, name, short text\n  s.a += `<td clas"
  "s=\"rightcol ${bottomrow}\"><div class=\"withmargin\">`\n// first line: link to channel, times, channel\n  s.a += '<d"
  "iv class=\"margin-bottom display-xs\">'\n  if (obj[9] > 0) {\n    s.a += '<a href=\"schedule.html\?channel='\n    s.a"
  " += obj[9]\n    s.a += '\">'\n  }\n  s.a += '<span class=\"normal-font\">'\n  s.a += obj[2]\n  if (obj[9] > 0) {\n   "
  " s.a += ' '\n    s.a += obj[10]\n  }\n  s.a += '</span>'\n  if (obj[9] > 0) s.a += '</a>'\n  s.a += '</div>'\n// sec&"
  "third line: Link to event, event title, short text\n  addEventRec(s, 'event_', obj[0], obj[11], '', obj[12], obj[13],"
  " '', '')\n  s.a += '</div></td></tr>'\n}\nfunction eventString(bottomrow, data) {\n  const s = Object.create(null)\n "
  " s.a = \"\"\n  addEvent(s, bottomrow, data)\n  return s.a\n}\n\n// existing recording\nfunction existingRecordingSR(s"
  ", col_span1, bottomrow, imdb_id, id, archiveDescr, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_"
  "duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder) {\n  if (archi"
  "veDescr.length != 0) col_span1--;\n  s.a += '<tr><td colspan='\n  s.a += col_span1.toString()\n  s.a += ' class=\"lef"
  "tcol '\n  s.a += bottomrow\n  s.a += '\">'\n  if (archiveDescr.length != 0) {\n    s.a += '</td><td class=\"action '"
  "\n    s.a += bottomrow\n    s.a += '\"> <img class=\"icon\" src=\"\" alt=\"on dvd\" title=\" />'\n    s.a += archiveD"
  "escr\n    s.a += '/>'\n  } else {\n    s.a += '<br/><table><tr><td class=\"noborder\">'\n    addErrorIcon(s, errors, "
  "durationDeviation)\n    s.a += '</td><td class=\"noborder\">'\n    addHdSdIcon(s, hd_sd, channel_name)\n    s.a += '<"
  "/td></tr></table>'\n  }\n  s.a += '</td><td class=\"td-hidden-xs '\n  s.a += bottomrow\n  s.a += '\"><div class=\"hid"
  "den-xs recording_day\">'\n  s.a += day_time_duration\n  s.a += '</div></td><td class=\"rightcol '\n  s.a += bottomrow"
  "\n  s.a += '\">'\n  addColEventRec(s, day_time_duration, 'recording_', id, name, folder, short_text, description, '',"
  " '')\n  s.a += '</td></tr>'\n}\nfunction existingRecordingString(col_span, bottomrow, imdb_id, id, archiveDescr, imag"
  "e, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, shor"
  "t_text, description, durationDeviation, folder) {\n  const s = Object.create(null)\n  s.a = \"\"\n  existingRecording"
  "SR(s, col_span, bottomrow, imdb_id, id, archiveDescr, image, pt, s_title, s_season_episode, s_runtime, s_date, day_ti"
  "me_duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder)\n  return s"
  ".a\n}\n\n\n</script>\n\n\n<link rel=\"stylesheet\" type=\"text/css\" href=\"css/styles.css\"/>\n<link rel=\"styleshee"
  "t\" type=\"text/css\" href=\"\"/>\n<link rel=\"stylesheet\" type=\"text/css\" href=\"css/siteprefs.css\"/>\n<script t"
  "ype=\"text/javascript\" src=\"js/live/header.js\"></script>\n<script type=\"text/javascript\" src=\"js/live/epg_tt_bo"
  "x.js\"></script>\n\n\n\n<!-- start of fixed page header -->\n<div id=\"header\" style=\"width: 100%; background-color"
  ": inherit\">\n<div id=\"padding\" style=\"display: none\"></div>\n<div id=\"content\">\n<!-- header content follows -"
  "->\n<div class=\"page_header\">\n<a href=\"\">\n<img src=\"\" alt=\"VDR Live!\" class=\"logo\"></img></a>\n</div>\n<d"
  "iv style=\"clear: both\"></div>\n\n\n\nstyle=\"visibility: hidden\"\n\n\n<div class=\"\"><div class=\"__elapsed\" id="
  "\"\"style=\"width: px\"></div></div>\n\n\n\n<a id=\"\"  href=\"vdr_request/\?param=\"  ><img src=\"\" alt=\"\"></img>"
  "</a> \n\n\n<a href=\"http://www.imdb.com/find\?s=all&q=\"\n<a href=\"http://www.imdb.com/title/\"\n target=\"_blank\""
  "><img src=\"\" alt=\"\" ></img></a> \n\n\n<a href=\"stream.html\?channelid_str=\"><img src=\"\" alt=\"\" ></img></a>"
  "\n\n\n\n<a href=\"playlist.m3u\?channel_str=\"><img src=\"\" alt=\"\" ></img></a>\n<a href=\"playlist.m3u\?channel=\""
  "><img src=\"\" alt=\"\" ></img></a>\n\n\n\n<a href=\"playlist.m3u\?recid=\"><img src=\"\" alt=\"\" ></img> </a>\n\n\n"
  "\n\t\t\n\t\t<a href=\"edit_timer.html\?epgid=\"><img src=\"\" alt=\"\"  /></a>\n\n\n\n\t<a href=\"edit_timer.html\?ti"
  "merid=\"><img src=\"\" alt=\"\"  /></a>\n\n\n\n\n\t<script type=\"text/javascript\" src=\"js/mootools/mootools.v1.11."
  "js\"></script>\n\t<script type=\"text/javascript\" src=\"js/live/liveajax.js\"></script>\n\t<script type=\"text/javas"
  "cript\" src=\"js/live/infowin.js\"></script>\n\t<script type=\"text/javascript\" src=\"js/live/hinttips.js\"></script"
  ">\n\t<script type=\"text/javascript\" src=\"js/live/browserwin.js\"></script>\n\t<script type=\"text/javascript\" src"
  "=\"js/live/pageenhance.js\"></script>\n\t<script type=\"text/javascript\"><!--\n\t\tvar liveEnhanced = new PageEnhanc"
  "e({\n\t\t\t\tinfoWinOptions: {\n\t\t\t\t\tbuttonimg: 'img/transparent.png',\n\t\t\t\t\tloadingMsg: '',\n\t\t\t\t\terr"
  "orMsg: ''\n\t\t\t\t},\n\t\t\t\tnotifyStrings: {\n\t\t\t\t\tsuccessMsg: '<img src=\"\" alt=\"\"> ',\n\t\t\t\t\terrorMs"
  "g: '<img src=\"\" alt=\"\"> '\n\t\t\t\t}\n\t\t\t});\n\t--></script>\n\t<script type=\"text/javascript\" src=\"js/live"
  "/vdr_status.js\"></script>\n\t<script type=\"text/javascript\"><!--\n\t\tvar InfoBox = new LiveVdrInfo('ibox.xml', 'i"
  "nfobox');\n\t\twindow.addEvent('domready', function(){\n\t\t\tInfoBox.request();\n\t\t});\n\t\twindow.addEvent('unloa"
  "d', function(){\n\t\t\tInfoBox.pageFinished();\n\t\t});\n\t--></script>\n\n\n\n<div id=\"infobox\">\n\t<div class=\"s"
  "tatuscontent\">\n\t\t<div class=\"st_header\">\n\t\t\t<div id=\"infobox_caption\" class=\"caption\"></div>\n\t\t\t<di"
  "v id=\"infobox_timenow\" class=\"now\">--:--</div>\n\t\t</div>\n\t\t<div class=\"st_content\">\n\t\t\t<div id=\"infob"
  "ox_name\" class=\"name\"></div>\n\t\t\t<div id=\"infobox_duration\" class=\"duration\">--:--</div>\n\t\t</div>\n\t\t<"
  "div class=\"st_controls\">\n\t\t\t<div class=\"st_update\">\n\t\t\t\t<a href=\"javascript:InfoBox.toggleUpdate()\" ><"
  "img id=\"statusReloadBtn\" src=\"\" alt=\"\" /></a>\n\t\t\t</div>\n\t\t\t<div id=\"infobox_recording_buttons\" style="
  "\"display: none\">\n\t\t\t\t\n\t\t\t\t\n\t\t\t\t\n\t\t\t\t\n\t\t\t\t\n\t\t\t</div>\n\t\t\t<div id=\"infobox_channel_b"
  "uttons\">\n\t\t\t\t\n\t\t\t\t\n\t\t\t</div>\n\t\t\t<div class=\"st_pbar\">\n\t\t\t\t\n\t\t\t</div>\n\t\t</div>\n\t</d"
  "iv>\n\t<div style=\"display: none;\">\n\t\t<span id=\"__infobox_request_err\"></span>\n\t\t<span id=\"__infobox_updat"
  "e_err\"></span>\n\t</div>\n</div>\n\n\n\n\t\n\t\n\t<a href=\"searchresults.html\?searchplain=\"><img src=\"\" alt=\""
  "\" ></img></a>\n\t\n\t\n\t\t\n\t\t<td class=\"action leftcol \"></td>\n\t\t<td class=\"action \"></td>\n             "
  "   \t\t<td class=\"action \"><a href=\"searchresults.html\?searchplain=\"><img src=\"\" alt=\"\" ></img></a></td>\n  "
  "              \t\t<td class=\"action \"></td>\n\t\t\t\t<td class=\"action \"></td>\n\t\t\t\t<td class=\"action \">\n"
  "\t\t\t\n\t\t</td>\n\n\n\n\t<div class=\"epg_description\" id=\"\">\n\t\t<div class=\"station\">\n\t\t\t<div class=\"b"
  "oxheader\">\n\n<div>\n<div class = \"caption menu\">\n  <a id=\"_epg_m\"     class = \"active\"   onclick=\"displayEP"
  "G('')\" ></a>\n| <a id=\"_scraper_m\" class = \"inactive\" onclick=\"displayScraper('')\"></a>\n| <a id=\"_actors_m\""
  "  class = \"inactive\" onclick=\"displayActors('')\" ></a>\n| <a id=\"_artwork_m\" class = \"inactive\" onclick=\"dis"
  "playArtwork('')\" ></a>\n</div>\n<div class=\"caption\"></div>\n</div>\n                        </div>\n\t\t</div>\n"
  "\t\t<div class=\"epg_content\">\n\t\t\t<div class=\"epg_tools\">\n\t\t\t\t\n\t\t\t</div>\n\t\t\t<div class=\"epg_info"
  "\">\n\t\t\t\t<div class=\"info nowrap\"><span class=\"bold\"></span></div>\n\t\t\t\t<div class=\"progress\"><div></di"
  "v></div>\n\t\t\t\t<div class=\"title\"></div>\n\t\t\t\t<div class=\"short\"></div>\n\t\t\t\t<div class=\"description"
  "\" id=_description>\n\t\t\t\t\t<span id = \"_epg_image\" class=\"epg_images\">\n         <a href=\"/epgimages/\" targ"
  "et=\"_blank\">\n\t\t\t\t\t\t<img src=\"/epgimages/\" class=\"epg_image\"/>\n         </a>\n         <a href=\"/tvscra"
  "per/\" target=\"_blank\">\n\t   <img src=\"/tvscraper/\" class=\"epg_image\"/>\n         </a>\n           <a href=\"/"
  "tvscraper/\" target=\"_blank\">\n             <img src=\"/tvscraper/\" class=\"epg_image\"/>\n           </a>\n      "
  "   <a href=\"/recimages//\" target=\"_blank\">\n\t\t\t\t\t\t<img src=\"/recimages//\" class=\"epg_image\"/>\n        "
  " </a>\n\t\t\t\t\t</span>\n\n<div id = '_scraper' hidden>\n\n  <div class=\"short\">         </div>\n  <div class=\"sh"
  "ort\"> </div>\n    <div class=\"short\"> SE </div>\n    <div class=\"short\">   </div>\n      <div class=\"short\">  "
  "/ </div>\n    <div class=\"short\"> </div>\n      <div class=\"short\"></div>\n\n      <div class=\"short\">   </div>"
  "\n      <div class=\"short\">     </div>\n      <a href=\"https://www.imdb.com/title/\" target=\"_blank\">  </a>\n  <"
  "div class=\"short\">        </div>\n  <div class=\"short\">       </div>\n  <div class=\"short\">         </div>\n  <"
  "div class=\"short\"><a href =\"\" target=\"_blank\"></a></div>\n  <div class=\"short\">   </div>\n  <div class=\"shor"
  "t\">       </div>\n  <div class=\"short\">     </div>\n  <div class=\"short\">  / </div>\n\n  <div class=\"short\">  "
  "       </div>\n    <a href=\"https://www.imdb.com/title/\" target=\"_blank\">  </a>\n\n    <div class=\"short\">     "
  "    </div>\n    <div class=\"short\">        </div>\n\n    <div class=\"short\"> </div>\n    <div class=\"short\">   "
  "    </div>\n    <div class=\"short\">         </div>\n    <div class=\"short\">         </div>\n\n      <div class=\""
  "short\">     </div>\n</div>\n\n<div id = '_actors' hidden>\n<table>\n      <tr>\n    <td>\n      <a href=\"/tvscraper"
  "/\" target=\"_blank\">\n        <img src=\"/tvscraper/\" alt=\": \" class=\"actor\">\n        </img>\n      </a>\n   "
  " </td>\n      </tr>\n      <tr></tr>\n      <tr>\n    <td>\n      <a href=\"/tvscraper/\" target=\"_blank\">\n       "
  " <img src=\"/tvscraper/\" alt=\": \" class=\"actor\">\n        </img>\n      </a>\n    </td>\n      </tr>\n      <tr>"
  "</tr>\n    </tr>\n    <tr></tr>\n</table>\n</div>\n\n<div id = '_artwork' hidden>\n\n\n\n</div>\n\n<div id = '_epg'>"
  "\n\t\t\t\t\t\t\t\t\t</div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n</div>\n\n\n  <a href=\"/tvscraper/\" target=\"_blank"
  "\">\n    <img src=\"/tvscraper/\" class=\"artwork\">\n    </img>\n  </a>\n\n\n\t<div class=\"epg_description\" id=\"a"
  "boutBox\">\n\t\t<div class=\"station\">\n\t\t\t<div class=\"boxheader\"><div><div class=\"caption\"></div></div></div"
  ">\n\t\t</div>\n\t\t<div class=\"epg_content\">\n\t\t\t<div>\n\t\t\t\t<div class=\"about_head\"><div><div></div></div>"
  "</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Thomas Keil (Thomas)</div>\n\t"
  "\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Sascha Volkenandt (LordJaxom)</div>\n\t\t"
  "\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Markus Ehrnsperger (MarkusE @ <a href=\"htt"
  "ps://www.vdr-portal.de\">VDR Portal</a>)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about"
  "_right\">Jasmin Jessich (jasminj)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right"
  "\">Dieter Hametner (tadi)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Christ"
  "ian Wieninger (winni)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Michael Br"
  "&uuml;ckner (skiller2k1)</div>\n\t\t\t\t<div class=\"about_head\"><div><div></div></div></div>\n\t\t\t\t<div class=\""
  "about_left\">:</div>\n\t\t\t\t<div class=\"about_right\"></div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<"
  "div class=\"about_right\"></div>\n\t\t\t\t<div class=\"about_head\"><div><div></div></div></div>\n\t\t\t\t<div class="
  "\"about_left\">EPGsearch:</div>\n\t\t\t\t<div class=\"about_right\">\n\t\t\t\t\t<img align=\"center\" src=\"\"/>\n\t"
  "\t\t\t\t\t: \n\t\t\t\t\t\t: \n\t\t\t\t\t(<a href=\"https://github.com/vdr-projects/vdr-plugin-epgsearch\" target=\"_b"
  "lank\"></a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class=\"about_left\">Streamdev server:</div>\n\t\t\t\t<div class=\"ab"
  "out_right\">\n\t\t\t\t\t<img align=\"center\" src=\"\"/>\n\t\t\t\t\t\t: \n\t\t\t\t\t\t: \n\t\t\t\t\t(<a href=\"https:"
  "//github.com/vdr-projects/vdr-plugin-streamdev\" target=\"_blank\"></a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class=\"a"
  "bout_head\"><div><div></div></div></div>\n\t\t\t\t<div class=\"about_line\">Movie information provided by <a target="
  "\"_blank\" href=\"https://www.themoviedb.org/\">TMDB</a></div>\n\t\t\t\t<div class=\"about_line\">Information provide"
  "d by TheTVDB.com. Please consider <a target=\"_blank\" href=\"https://u10505776.ct.sendgrid.net/ls/click\?upn=xMYYCP1"
  "3hVd-2BZPpbVcMPHeLXfv-2BPRdIsKm2qSeirIHi7kH9am8IxD-2BavFbeqGqIXIcjH_INgc0CXRkIvGU-2BJ1W6HLAynNbR0UBoMb2tkpDdezO3QRj-2"
  "FQPQAMrtJKVcB0N7eSvbYpjQTDNOQBf2pb94uDgGr0-2BXyXFk7Oyfva30BASYCRLvtRQyi5eOCAbH8fon7UETlPydobeLA3Recu9OsXol8c7Ng4pDAsH"
  "6KsFF8CH7HQoVxivnpKrQW2v4ek7U-2BYlWmH31o9Koke3vq-2FDsQ0P-2BiKLECU3LgttsntUcN8fnUs-3D\">supporting them</a></div>\n\t"
  "\t\t\t<div class=\"about_head\"><div><div></div></div></div>\n\t\t\t\t<div class=\"about_line\">:<br/>\n\t\t\t\t\t<a "
  "target=\"_blank\" href=\"https://github.com/MarkusEh/vdr-plugin-live/issues\">https://github.com/MarkusEh/vdr-plugin-"
  "live/issues</a></div>\n\t\t\t\t<div class=\"about_head\"><div><div>&nbsp;</div></div></div>\n\t\t\t</div>\n\t\t</div>"
  "\n\t</div>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    doc_type(*this, "doc_type"),
    create_html_js(*this, "create_html_js"),
    stylesheets(*this, "stylesheets"),
    logo(*this, "logo"),
    hide_element(*this, "hide_element"),
    progressbar(*this, "progressbar"),
    ajax_action_href(*this, "ajax_action_href"),
    imdb_info_href(*this, "imdb_info_href"),
    hls_channel(*this, "hls_channel"),
    m3u_playlist_channel(*this, "m3u_playlist_channel"),
    m3u_playlist_recording(*this, "m3u_playlist_recording"),
    event_timer(*this, "event_timer"),
    edit_timer(*this, "edit_timer"),
    ajax_js(*this, "ajax_js"),
    infobox(*this, "infobox"),
    epg_tool_box(*this, "epg_tool_box"),
    epg_tt_box(*this, "epg_tt_box"),
    media(*this, "media"),
    about_tt_box(*this, "about_tt_box")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n\n
  reply.out() << _tntChunks[3]; // \n
  reply.out() << _tntChunks[4]; // \n\n
  reply.out() << _tntChunks[37]; // \n\n
  reply.out() << _tntChunks[40]; // \n
  reply.out() << _tntChunks[41]; // \n\n
  reply.out() << _tntChunks[48]; // \n
  reply.out() << _tntChunks[49]; // \n\n
  reply.out() << _tntChunks[51]; // \n
  reply.out() << _tntChunks[52]; // \n\n
  reply.out() << _tntChunks[59]; // \n
  reply.out() << _tntChunks[60]; // \n\n
  reply.out() << _tntChunks[71]; // \n
  reply.out() << _tntChunks[72]; // \n\n
  reply.out() << _tntChunks[80]; // \n
  reply.out() << _tntChunks[81]; // \n\n
  reply.out() << _tntChunks[86]; // \n
  reply.out() << _tntChunks[87]; // \n\n
  reply.out() << _tntChunks[96]; // \n
  reply.out() << _tntChunks[97]; // \n\n
  reply.out() << _tntChunks[103]; // \n
  reply.out() << _tntChunks[104]; // \n\n
  reply.out() << _tntChunks[111]; // \n
  reply.out() << _tntChunks[112]; // \n\n
  reply.out() << _tntChunks[117]; // \n\n
  reply.out() << _tntChunks[118]; // \n\n
  reply.out() << _tntChunks[128]; // \n
  reply.out() << _tntChunks[129]; // \n\n
  reply.out() << _tntChunks[144]; // \n
  reply.out() << _tntChunks[145]; // \n\n
  reply.out() << _tntChunks[179]; // \n
  reply.out() << _tntChunks[180]; // \n\n
  reply.out() << _tntChunks[345]; // \n
  reply.out() << _tntChunks[346]; // \n
  reply.out() << _tntChunks[350]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::doc_type_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::doc_type " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[2]; // <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::create_html_js_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::create_html_js " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 62 "pageelems.ecpp"

const char *lf;
if (LiveSetup().GetUseAjax()) lf = "<br/>";
else lf = "&#13;";

  reply.out() << _tntChunks[5]; // <script>\nfunction addErrorIcon(s, numErrors, durationDeviation) {\n  if (numErrors <= -100) return\n  s.a += '<div class="recording_errors"><img class="icon" src="
#line 70 "pageelems.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[6]; // '\n  if (durationDeviation > 300 || numErrors  > 0) s.a += 'RecordingErrors.png'\n  else if (durationDeviation > 180) s.a += 'NotCheckedForRecordingErrors.png'\n  else {\n    if (numErrors == 0) s.a += 'NoRecordingErrors.png'\n    if (numErrors  > 0) s.a += 'RecordingErrors.png'\n    if (numErrors  < 0) s.a += 'NotCheckedForRecordingErrors.png'\n  }\n  s.a += '" width = "16px" title="'\n  if (numErrors == 0) s.a += '
#line 79 "pageelems.ecpp"
  reply.sout() << (tr("No recording errors"));
  reply.out() << _tntChunks[7]; // '\n  if (numErrors  > 0) s.a += '
#line 80 "pageelems.ecpp"
  reply.sout() << (tr("Number of recording errors:"));
  reply.out() << _tntChunks[8]; //  ' + String(numErrors)\n  if (numErrors  < 0) s.a += '
#line 81 "pageelems.ecpp"
  reply.sout() << (tr("Recording errors unknown"));
  reply.out() << _tntChunks[9]; // '\n  s.a += '
#line 82 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[10]; // '\n  s.a += '
#line 83 "pageelems.ecpp"
  reply.sout() << (tr("Duration deviation from event length"));
  reply.out() << _tntChunks[11]; // '\n  s.a += ': '\n  addTime(s, durationDeviation)\n  s.a += ' '\n  s.a += '
#line 87 "pageelems.ecpp"
  reply.sout() << (tr("min"));
  reply.out() << _tntChunks[12]; // '\n  s.a += '" /> </div>'\n}\n\nfunction addHdSdIcon(s, hdsd, toolTip) {\n  s.a += '<div class="recording_sd_hd"><img class="icon" src="
#line 92 "pageelems.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[13]; // '\n  s.a += hdsd\n  s.a += 'd.png" width = "25px" title="'\n  s.a += toolTip\n  s.a += '" /></div>'\n}\n\nfunction IMDBS(s, im_db, name) {\n  if (im_db.length == 0) {\n    s.a += '<a href="http://www.imdb.com/find\?s=all&q='\n    s.a += name\n  } else {\n    s.a += '<a href="https://www.imdb.com/title/'\n    s.a += im_db\n  }\n  s.a += \n   '" target="_blank"><img class="icon" src="
#line 108 "pageelems.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[14]; // imdb.png" title="
#line 108 "pageelems.ecpp"
  reply.sout() << (tr("Find more at the Internet Movie Database."));
  reply.out() << _tntChunks[15]; // "/></a>'\n}\n\n
  reply.out() << _tntChunks[16]; // \nfunction addEvent(s, bottomrow_i, obj) {\n// first column, timer /red or green, ...\n  let bottomrow = ''\n  if (bottomrow_i != 0) bottomrow = 'bottomrow'\n  s.a += `<tr><td class="action leftcol ${bottomrow}">`\n  if (obj[1].length != 0) {\n    s.a += '<a href="edit_timer.html\?timerid=timer_'\n    s.a += obj[1]\n    s.a += '"><img class="icon" src="
#line 137 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record_timer.png") );
  reply.out() << _tntChunks[17]; // " title="
#line 137 "pageelems.ecpp"
  reply.sout() << (tr("Edit timer"));
  reply.out() << _tntChunks[18]; // " />'\n  } else {\n    s.a += '<a href="edit_timer.html\?epgid=event_'\n    s.a += obj[0]\n    s.a += '"><img class="icon" src="
#line 141 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record.png") );
  reply.out() << _tntChunks[19]; // " title="
#line 141 "pageelems.ecpp"
  reply.sout() << (tr("Record this"));
  reply.out() << _tntChunks[20]; // " />'\n  }\n  s.a += '</a>'\n
#line 144 "pageelems.ecpp"
if (LiveFeatures<features::epgsearch>().Recent() ) { 
  reply.out() << _tntChunks[21]; //   s.a += '<a href="searchresults.html\?searchplain='\n  s.a += obj[11]\n  s.a += '"><img class="icon" src="
#line 147 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[22]; // " title="
#line 147 "pageelems.ecpp"
  reply.sout() << (tr("Search for repeats."));
  reply.out() << _tntChunks[23]; // "/></a>'\n
#line 148 "pageelems.ecpp"
 } if (LiveSetup().GetShowIMDb() ) { 
  reply.out() << _tntChunks[24]; //   IMDBS(s, obj[14], obj[11])\n
#line 150 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[25]; //   s.a += '</td>'\n// second col, dependent on width: channel\n  if (obj[9] > 0) {\n    s.a += `<td class="td-hidden-xs ${bottomrow}"><div class="hidden-xs withmargin"><a href="schedule.html\?channel=`\n    s.a += obj[9]\n    s.a += '">'\n    s.a += obj[10]\n    s.a += '</a></div></td>'\n  }\n// third col: image\n
#line 161 "pageelems.ecpp"
 if (!LiveSetup().GetTvscraperImageDir().empty() ) { 
  reply.out() << _tntChunks[26]; //     s.a += `<td class="enlarge-image ${bottomrow}">`\n    addScraperImageTitle(s, obj[3], obj[4], obj[5], obj[6], obj[7], obj[8], '
#line 163 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[27]; // ');\n    s.a += '</td>'\n
#line 165 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[28]; //   s.a += `<td class="td-hidden-xs ${bottomrow}"><div class="hidden-xs withmargin">`\n  s.a += obj[2]\n  s.a += '</div></td>'\n// col with times, channel, name, short text\n  s.a += `<td class="rightcol ${bottomrow}"><div class="withmargin">`\n// first line: link to channel, times, channel\n  s.a += '<div class="margin-bottom display-xs">'\n  if (obj[9] > 0) {\n    s.a += '<a href="schedule.html\?channel='\n    s.a += obj[9]\n    s.a += '">'\n  }\n  s.a += '<span class="normal-font">'\n  s.a += obj[2]\n  if (obj[9] > 0) {\n    s.a += ' '\n    s.a += obj[10]\n  }\n  s.a += '</span>'\n  if (obj[9] > 0) s.a += '</a>'\n  s.a += '</div>'\n// sec&third line: Link to event, event title, short text\n  addEventRec(s, 'event_', obj[0], obj[11], '', obj[12], obj[13], '
#line 188 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[29]; // ', '
#line 188 "pageelems.ecpp"
  reply.sout() << (tr("Click to view details."));
  reply.out() << _tntChunks[30]; // ')\n  s.a += '</div></td></tr>'\n}\nfunction eventString(bottomrow, data) {\n  const s = Object.create(null)\n  s.a = ""\n  addEvent(s, bottomrow, data)\n  return s.a\n}\n\n// existing recording\nfunction existingRecordingSR(s, col_span1, bottomrow, imdb_id, id, archiveDescr, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder) {\n  if (archiveDescr.length != 0) col_span1--;\n  s.a += '<tr><td colspan='\n  s.a += col_span1.toString()\n  s.a += ' class="leftcol '\n  s.a += bottomrow\n  s.a += '">
#line 205 "pageelems.ecpp"
  reply.sout() << ( tr("Existing Recording:") );
  reply.out() << _tntChunks[31]; // '\n  if (archiveDescr.length != 0) {\n    s.a += '</td><td class="action '\n    s.a += bottomrow\n    s.a += '"> <img class="icon" src="
#line 209 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << _tntChunks[32]; // " alt="on dvd" title=" />'\n    s.a += archiveDescr\n    s.a += '/>'\n
#line 212 "pageelems.ecpp"

#if VDRVERSNUM >= 20505

  reply.out() << _tntChunks[33]; //   } else {\n    s.a += '<br/><table><tr><td class="noborder">'\n    addErrorIcon(s, errors, durationDeviation)\n    s.a += '</td><td class="noborder">'\n    addHdSdIcon(s, hd_sd, channel_name)\n    s.a += '</td></tr></table>'\n
#line 221 "pageelems.ecpp"

#endif

  reply.out() << _tntChunks[34]; //   }\n  s.a += '</td><td class="td-hidden-xs '\n  s.a += bottomrow\n  s.a += '"><div class="hidden-xs recording_day">'\n  s.a += day_time_duration\n  s.a += '</div></td><td class="rightcol '\n  s.a += bottomrow\n  s.a += '">'\n  addColEventRec(s, day_time_duration, 'recording_', id, name, folder, short_text, description, '
#line 232 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[35]; // ', '
#line 232 "pageelems.ecpp"
  reply.sout() << (tr("Click to view details."));
  reply.out() << _tntChunks[36]; // ')\n  s.a += '</td></tr>'\n}\nfunction existingRecordingString(col_span, bottomrow, imdb_id, id, archiveDescr, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder) {\n  const s = Object.create(null)\n  s.a = ""\n  existingRecordingSR(s, col_span, bottomrow, imdb_id, id, archiveDescr, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder)\n  return s.a\n}\n\n\n</script>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::stylesheets_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::stylesheets " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[38]; // <link rel="stylesheet" type="text/css" href="css/styles.css"/>\n<link rel="stylesheet" type="text/css" href="
#line 249 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("css", "theme.css") );
  reply.out() << _tntChunks[39]; // "/>\n<link rel="stylesheet" type="text/css" href="css/siteprefs.css"/>\n<script type="text/javascript" src="js/live/header.js"></script>\n<script type="text/javascript" src="js/live/epg_tt_box.js"></script>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::logo_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::logo " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[42]; // <!-- start of fixed page header -->\n<div id="header" style="width: 100%; background-color: inherit">\n<div id="padding" style="display: none"></div>\n<div id="content">\n<!-- header content follows -->\n
#line 263 "pageelems.ecpp"

	if (LiveSetup().GetShowLogo()
		|| (LiveSetup().GetUseAjax() && LiveSetup().GetShowInfoBox())) {

  reply.out() << _tntChunks[43]; // <div class="page_header">\n
#line 268 "pageelems.ecpp"

		if (LiveSetup().GetShowLogo()) {

  reply.out() << _tntChunks[44]; // <a href="
#line 271 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetStartScreenLink());
  reply.out() << _tntChunks[45]; // ">\n<img src="
#line 272 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "logo.png") );
  reply.out() << _tntChunks[46]; // " alt="VDR Live!" class="logo"></img></a>\n
#line 273 "pageelems.ecpp"

		}

#line 276 "pageelems.ecpp"
if (LiveSetup().GetUseAjax() && LiveSetup().GetShowInfoBox()) { 
  // <& infobox ...
  { 
#line 276 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 276 "pageelems.ecpp"
  main().infobox(request, reply, _tnt_cq0);
    // &>
  }
#line 276 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[47]; // </div>\n<div style="clear: both"></div>\n
#line 279 "pageelems.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hide_element_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hide_element " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int hide = qparam.get< int >("hide", ( 1));
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 290 "pageelems.ecpp"
 if (hide) { 
  reply.out() << _tntChunks[50]; // style="visibility: hidden"
#line 290 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::progressbar_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::progressbar " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int progress = qparam.get< int >("progress", ( 0));
std::string id = qparam.get< std::string >("id");
int duration = qparam.get< int >("duration", ( -1));
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 301 "pageelems.ecpp"

	std::string cls("__progress");
	if ((duration >= 0) && ((progress < 0) || (duration == 0)))
		cls +="_invisible";

  reply.out() << _tntChunks[53]; // <div class="
#line 306 "pageelems.ecpp"
  reply.sout() << ( cls );
  reply.out() << _tntChunks[54]; // "><div class="__elapsed" 
#line 306 "pageelems.ecpp"
 if (!id.empty()) { 
  reply.out() << _tntChunks[55]; // id="
#line 306 "pageelems.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[56]; // "
#line 306 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[57]; // style="width: 
#line 306 "pageelems.ecpp"
  reply.sout() << ( progress );
  reply.out() << _tntChunks[58]; // px"></div></div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_action_href_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::ajax_action_href " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string action = qparam.get< std::string >("action");
std::string tip = qparam.get< std::string >("tip");
std::string param = qparam.get< std::string >("param");
std::string image = qparam.get< std::string >("image");
std::string alt = qparam.get< std::string >("alt");
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 320 "pageelems.ecpp"
 { 
  reply.out() << _tntChunks[61]; // <a 
#line 320 "pageelems.ecpp"
 if (!id.empty()) { 
  reply.out() << _tntChunks[62]; // id="
#line 320 "pageelems.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[63]; // " 
#line 320 "pageelems.ecpp"
 } 
  // <& hide_element ...
  { 
#line 320 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 320 "pageelems.ecpp"
    _tnt_cq1.add( "hide", (id.empty()? 0 : 1));
#line 320 "pageelems.ecpp"
  main().hide_element(request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[64]; //  href="vdr_request/
#line 320 "pageelems.ecpp"
  reply.sout() << ( action );
  reply.out() << _tntChunks[65]; // \?param=
#line 320 "pageelems.ecpp"
  reply.sout() << ( param );
  reply.out() << _tntChunks[66]; // " 
#line 320 "pageelems.ecpp"
if (!tip.empty()) { 
  // <& tooltip.hint ...
  { 
#line 320 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 320 "pageelems.ecpp"
    _tnt_cq2.add( "text", (tip));
#line 320 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[67]; //  
#line 320 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[68]; // ><img src="
#line 320 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", image) );
  reply.out() << _tntChunks[69]; // " alt="
#line 320 "pageelems.ecpp"
  reply.sout() << ( alt );
  reply.out() << _tntChunks[70]; // "></img></a> 
#line 320 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::imdb_info_href_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::imdb_info_href " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 330 "pageelems.ecpp"

// if (LiveSetup().GetShowIMDb())
{
if (s_IMDB_ID.empty() ) { 
  reply.out() << _tntChunks[73]; // <a href="http://www.imdb.com/find\?s=all&q=
#line 334 "pageelems.ecpp"
  reply.sout() << ( StringUrlEncode(title) );
  reply.out() << _tntChunks[74]; // "\n
#line 335 "pageelems.ecpp"
 } else { 
  reply.out() << _tntChunks[75]; // <a href="http://www.imdb.com/title/
#line 336 "pageelems.ecpp"
  reply.sout() << ( s_IMDB_ID );
  reply.out() << _tntChunks[76]; // "\n
#line 337 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[77]; //  target="_blank"><img src="
#line 338 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "imdb.png") );
  reply.out() << _tntChunks[78]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 338 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 338 "pageelems.ecpp"
    _tnt_cq3.add( "text", (tr("Find more at the Internet Movie Database.")));
#line 338 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[79]; // ></img></a> 
#line 338 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hls_channel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hls_channel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string channelId = qparam.get< std::string >("channelId");
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 347 "pageelems.ecpp"

if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded()) {

  reply.out() << _tntChunks[82]; // <a href="stream.html\?channelid_str=
#line 350 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[83]; // "><img src="
#line 350 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stream_button.png") );
  reply.out() << _tntChunks[84]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 350 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 350 "pageelems.ecpp"
    _tnt_cq4.add( "text", (tr("Stream this channel into browser.")));
#line 350 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[85]; // ></img></a>\n
#line 351 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_playlist_channel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::m3u_playlist_channel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string channelId = qparam.get< std::string >("channelId");
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 362 "pageelems.ecpp"

if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded()) {
#if TNTVERSION >= 30000

  reply.out() << _tntChunks[88]; // <a href="playlist.m3u\?channel_str=
#line 366 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[89]; // "><img src="
#line 366 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[90]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 366 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 366 "pageelems.ecpp"
    _tnt_cq5.add( "text", (tr("Stream this channel into media player.")));
#line 366 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[91]; // ></img></a>\n
#line 367 "pageelems.ecpp"

#else

  reply.out() << _tntChunks[92]; // <a href="playlist.m3u\?channel=
#line 370 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[93]; // "><img src="
#line 370 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[94]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 370 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 370 "pageelems.ecpp"
    _tnt_cq6.add( "text", (tr("Stream this channel into media player.")));
#line 370 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[95]; // ></img></a>\n
#line 371 "pageelems.ecpp"

#endif
}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_playlist_recording_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::m3u_playlist_recording " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string recid = qparam.get< std::string >("recid");
std::string linkText = qparam.get< std::string >("linkText");
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 384 "pageelems.ecpp"

#if TNT_WATCHDOG_SILENCE
{

  reply.out() << _tntChunks[98]; // <a href="playlist.m3u\?recid=
#line 387 "pageelems.ecpp"
  reply.sout() << ( recid );
  reply.out() << _tntChunks[99]; // "><img src="
#line 387 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[100]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 387 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 387 "pageelems.ecpp"
    _tnt_cq7.add( "text", (tr("Stream this recording into media player.")));
#line 387 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[101]; // ></img> 
#line 387 "pageelems.ecpp"
  reply.sout() << ( linkText );
  reply.out() << _tntChunks[102]; // </a>\n
#line 388 "pageelems.ecpp"

}
#endif

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::event_timer_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::event_timer " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string epgid = qparam.get< std::string >("epgid");
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 400 "pageelems.ecpp"

	tChannelID channelid;
	tEventID eventid;
	EpgEvents::DecodeDomId(epgid, channelid, eventid);
	const cTimer* timer = LiveTimerManager().GetTimer(eventid, channelid);
	if (timer) {

  reply.out() << _tntChunks[105]; // \t\t
  // <& pageelems.edit_timer ...
  { 
#line 407 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 407 "pageelems.ecpp"
    _tnt_cq8.add( "imgName", ("record_timer.png"));
#line 407 "pageelems.ecpp"
    _tnt_cq8.add( "timerId", (LiveTimerManager().GetTimers().GetTimerId(*timer)));
#line 407 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[106]; // \n
#line 408 "pageelems.ecpp"

	}
	else {

  reply.out() << _tntChunks[107]; // \t\t<a href="edit_timer.html\?epgid=
#line 412 "pageelems.ecpp"
  reply.sout() << ( epgid );
  reply.out() << _tntChunks[108]; // "><img src="
#line 412 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record.png") );
  reply.out() << _tntChunks[109]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 412 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 412 "pageelems.ecpp"
    _tnt_cq9.add( "text", (tr("Record this")));
#line 412 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[110]; //  /></a>\n
#line 413 "pageelems.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_timer_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::edit_timer " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string timerId = qparam.get< std::string >("timerId");
std::string imgName = qparam.get< std::string >("imgName", ( "edit.png"));
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[113]; // \t<a href="edit_timer.html\?timerid=
#line 425 "pageelems.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timerId) );
  reply.out() << _tntChunks[114]; // "><img src="
#line 425 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", imgName) );
  reply.out() << _tntChunks[115]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 425 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 425 "pageelems.ecpp"
    _tnt_cq10.add( "text", (tr("Edit timer")));
#line 425 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[116]; //  /></a>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_js_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::ajax_js " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 432 "pageelems.ecpp"

	if (LiveSetup().GetUseAjax()) {

  reply.out() << _tntChunks[119]; // \t<script type="text/javascript" src="js/mootools/mootools.v1.11.js"></script>\n\t<script type="text/javascript" src="js/live/liveajax.js"></script>\n\t<script type="text/javascript" src="js/live/infowin.js"></script>\n\t<script type="text/javascript" src="js/live/hinttips.js"></script>\n\t<script type="text/javascript" src="js/live/browserwin.js"></script>\n\t<script type="text/javascript" src="js/live/pageenhance.js"></script>\n\t<script type="text/javascript"><!--\n\t\tvar liveEnhanced = new PageEnhance({\n\t\t\t\tinfoWinOptions: {\n\t\t\t\t\tbuttonimg: 'img/transparent.png',\n\t\t\t\t\tloadingMsg: '
#line 445 "pageelems.ecpp"
  reply.sout() << ( tr("loading data") );
  reply.out() << _tntChunks[120]; // ',\n\t\t\t\t\terrorMsg: '
#line 446 "pageelems.ecpp"
  reply.sout() << ( tr("an error occured!") );
  reply.out() << _tntChunks[121]; // '\n\t\t\t\t},\n\t\t\t\tnotifyStrings: {\n\t\t\t\t\tsuccessMsg: '<img src="
#line 449 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "active.png") );
  reply.out() << _tntChunks[122]; // " alt=""> 
#line 449 "pageelems.ecpp"
  reply.sout() << ( tr("Request succeeded!") );
  reply.out() << _tntChunks[123]; // ',\n\t\t\t\t\terrorMsg: '<img src="
#line 450 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[124]; // " alt=""> 
#line 450 "pageelems.ecpp"
  reply.sout() << ( tr("Request failed!") );
  reply.out() << _tntChunks[125]; // '\n\t\t\t\t}\n\t\t\t});\n\t--></script>\n
#line 454 "pageelems.ecpp"

		if (LiveSetup().GetShowInfoBox()) {

  reply.out() << _tntChunks[126]; // \t<script type="text/javascript" src="js/live/vdr_status.js"></script>\n\t<script type="text/javascript"><!--\n\t\tvar InfoBox = new LiveVdrInfo('ibox.xml', 'infobox');\n\t\twindow.addEvent('domready', function(){\n\t\t\tInfoBox.request(
#line 461 "pageelems.ecpp"
 if (update_status) { reply.sout() << "true"; } else { reply.sout() << "false"; } 
  reply.out() << _tntChunks[127]; // );\n\t\t});\n\t\twindow.addEvent('unload', function(){\n\t\t\tInfoBox.pageFinished();\n\t\t});\n\t--></script>\n
#line 467 "pageelems.ecpp"

		}

#line 470 "pageelems.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::infobox_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::infobox " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[130]; // <div id="infobox">\n\t<div class="statuscontent">\n\t\t<div class="st_header">\n\t\t\t<div id="infobox_caption" class="caption">
#line 481 "pageelems.ecpp"
  reply.sout() << ( tr("retrieving status ...") );
  reply.out() << _tntChunks[131]; // </div>\n\t\t\t<div id="infobox_timenow" class="now">--:--</div>\n\t\t</div>\n\t\t<div class="st_content">\n\t\t\t<div id="infobox_name" class="name"></div>\n\t\t\t<div id="infobox_duration" class="duration">--:--</div>\n\t\t</div>\n\t\t<div class="st_controls">\n\t\t\t<div class="st_update">\n\t\t\t\t<a href="javascript:InfoBox.toggleUpdate()" 
  // <& tooltip.hint ...
  { 
#line 490 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 490 "pageelems.ecpp"
    _tnt_cq11.add( "text", (tr("Toggle updates on/off.")));
#line 490 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[132]; // ><img id="statusReloadBtn" src="
#line 490 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stop_update.png") );
  reply.out() << _tntChunks[133]; // " alt="" /></a>\n\t\t\t</div>\n\t\t\t<div id="infobox_recording_buttons" style="display: none">\n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 493 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 493 "pageelems.ecpp"
    _tnt_cq12.add( "action", ("stop_recording"));
#line 493 "pageelems.ecpp"
    _tnt_cq12.add( "id", ("infobox_stop"));
#line 493 "pageelems.ecpp"
    _tnt_cq12.add( "image", ("stop.png"));
#line 493 "pageelems.ecpp"
    _tnt_cq12.add( "tip", (tr("stop playback")));
#line 493 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[134]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 494 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 494 "pageelems.ecpp"
    _tnt_cq13.add( "action", ("play_recording"));
#line 494 "pageelems.ecpp"
    _tnt_cq13.add( "id", ("infobox_play"));
#line 494 "pageelems.ecpp"
    _tnt_cq13.add( "image", ("play.png"));
#line 494 "pageelems.ecpp"
    _tnt_cq13.add( "tip", (tr("resume playback")));
#line 494 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[135]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 495 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 495 "pageelems.ecpp"
    _tnt_cq14.add( "action", ("pause_recording"));
#line 495 "pageelems.ecpp"
    _tnt_cq14.add( "id", ("infobox_pause"));
#line 495 "pageelems.ecpp"
    _tnt_cq14.add( "image", ("pause.png"));
#line 495 "pageelems.ecpp"
    _tnt_cq14.add( "tip", (tr("pause playback")));
#line 495 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[136]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 496 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 496 "pageelems.ecpp"
    _tnt_cq15.add( "action", ("rwd_recording"));
#line 496 "pageelems.ecpp"
    _tnt_cq15.add( "id", ("infobox_rwd"));
#line 496 "pageelems.ecpp"
    _tnt_cq15.add( "image", ("rwd.png"));
#line 496 "pageelems.ecpp"
    _tnt_cq15.add( "tip", (tr("fast rewind")));
#line 496 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[137]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 497 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 497 "pageelems.ecpp"
    _tnt_cq16.add( "action", ("ffw_recording"));
#line 497 "pageelems.ecpp"
    _tnt_cq16.add( "id", ("infobox_ffw"));
#line 497 "pageelems.ecpp"
    _tnt_cq16.add( "image", ("ffw.png"));
#line 497 "pageelems.ecpp"
    _tnt_cq16.add( "tip", (tr("fast forward")));
#line 497 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[138]; // \n\t\t\t</div>\n\t\t\t<div id="infobox_channel_buttons">\n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 500 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 500 "pageelems.ecpp"
    _tnt_cq17.add( "action", ("switch_channel"));
#line 500 "pageelems.ecpp"
    _tnt_cq17.add( "id", ("infobox_prevchan"));
#line 500 "pageelems.ecpp"
    _tnt_cq17.add( "image", ("one_downarrow.png"));
#line 500 "pageelems.ecpp"
    _tnt_cq17.add( "tip", (tr("previous channel")));
#line 500 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[139]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 501 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 501 "pageelems.ecpp"
    _tnt_cq18.add( "action", ("switch_channel"));
#line 501 "pageelems.ecpp"
    _tnt_cq18.add( "id", ("infobox_nextchan"));
#line 501 "pageelems.ecpp"
    _tnt_cq18.add( "image", ("one_uparrow.png"));
#line 501 "pageelems.ecpp"
    _tnt_cq18.add( "tip", (tr("next channel")));
#line 501 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[140]; // \n\t\t\t</div>\n\t\t\t<div class="st_pbar">\n\t\t\t\t
  // <& progressbar ...
  { 
#line 504 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 504 "pageelems.ecpp"
    _tnt_cq19.add( "id", ("infobox_elapsed"));
#line 504 "pageelems.ecpp"
  main().progressbar(request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[141]; // \n\t\t\t</div>\n\t\t</div>\n\t</div>\n\t<div style="display: none;">\n\t\t<span id="__infobox_request_err">
#line 509 "pageelems.ecpp"
  reply.sout() << ( tr("No server response!") );
  reply.out() << _tntChunks[142]; // </span>\n\t\t<span id="__infobox_update_err">
#line 510 "pageelems.ecpp"
  reply.sout() << ( tr("Failed to update infobox!") );
  reply.out() << _tntChunks[143]; // </span>\n\t</div>\n</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epg_tool_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::epg_tool_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int detail = qparam.get< int >("detail");
std::string epgid = qparam.get< std::string >("epgid");
std::string title = qparam.get< std::string >("title");
time_t startTime = qparam.get< time_t >("startTime");
time_t endTime = qparam.get< time_t >("endTime");
int lastCurrentChanel = qparam.get< int >("lastCurrentChanel", ( int()));
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 527 "pageelems.ecpp"

	int duration = EpgEvents::Duration(startTime, endTime);
	int elapsed = EpgEvents::ElapsedTime(startTime, endTime);
    tEventID eventId = tEventID();
	tChannelID channelId = tChannelID();

	EpgEvents::DecodeDomId(epgid, channelId, eventId);
	if (detail) { // output for vertical toolbox

  reply.out() << _tntChunks[146]; // \t
  // <& pageelems.event_timer ...
  { 
#line 536 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 536 "pageelems.ecpp"
    _tnt_cq20.add( "epgid", (epgid));
#line 536 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[147]; // \n\t
  // <& pageelems.ajax_action_href ...
  { 
#line 537 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 537 "pageelems.ecpp"
    _tnt_cq21.add( "action", "switch_channel");
#line 537 "pageelems.ecpp"
    _tnt_cq21.add( "alt", "");
#line 537 "pageelems.ecpp"
    _tnt_cq21.add( "image", "zap.png");
#line 537 "pageelems.ecpp"
    _tnt_cq21.add( "param", (channelId));
#line 537 "pageelems.ecpp"
    _tnt_cq21.add( "tip", (tr("Switch to this channel.")));
#line 537 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << _tntChunks[148]; // \n
#line 538 "pageelems.ecpp"

		if (LiveFeatures<features::epgsearch>().Recent() && eventId != 0) {

  reply.out() << _tntChunks[149]; // \t<a href="searchresults.html\?searchplain=
#line 541 "pageelems.ecpp"
  reply.sout() << ( StringEscapeAndBreak(title) );
  reply.out() << _tntChunks[150]; // "><img src="
#line 541 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[151]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 541 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 541 "pageelems.ecpp"
    _tnt_cq22.add( "text", (tr("Search for repeats.")));
#line 541 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq22);
    // &>
  }
  reply.out() << _tntChunks[152]; // ></img></a>\n
#line 542 "pageelems.ecpp"

		}
		if ((duration == 0) || (elapsed >= 0)) {

  reply.out() << _tntChunks[153]; // \t
  // <& pageelems.hls_channel ...
  { 
#line 546 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 546 "pageelems.ecpp"
    _tnt_cq23.add( "channelId", (channelId));
#line 546 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq23);
    // &>
  }
  reply.out() << _tntChunks[154]; // \n\t
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 547 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 547 "pageelems.ecpp"
    _tnt_cq24.add( "channelId", (channelId));
#line 547 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << _tntChunks[155]; // \n
#line 548 "pageelems.ecpp"

		}
	if (eventId != 0) {

  reply.out() << _tntChunks[156]; // \t\t
  // <& pageelems.imdb_info_href ...
  { 
#line 552 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 552 "pageelems.ecpp"
    _tnt_cq25.add( "s_IMDB_ID", (s_IMDB_ID));
#line 552 "pageelems.ecpp"
    _tnt_cq25.add( "title", (title));
#line 552 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << _tntChunks[157]; // \n
#line 553 "pageelems.ecpp"

		}
	}
	else { // table output

  reply.out() << _tntChunks[158]; // \t\t<td class="action leftcol 
#line 558 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[159]; // ">
  // <& pageelems.event_timer ...
  { 
#line 558 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq26;
#line 558 "pageelems.ecpp"
    _tnt_cq26.add( "epgid", (epgid));
#line 558 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq26);
    // &>
  }
  reply.out() << _tntChunks[160]; // </td>\n\t\t<td class="action 
#line 559 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[161]; // ">
  // <& pageelems.ajax_action_href ...
  { 
#line 559 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq27;
#line 559 "pageelems.ecpp"
    _tnt_cq27.add( "action", "switch_channel");
#line 559 "pageelems.ecpp"
    _tnt_cq27.add( "alt", "");
#line 559 "pageelems.ecpp"
    _tnt_cq27.add( "image", "zap.png");
#line 559 "pageelems.ecpp"
    _tnt_cq27.add( "param", (channelId));
#line 559 "pageelems.ecpp"
    _tnt_cq27.add( "tip", (tr("Switch to this channel.")));
#line 559 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq27);
    // &>
  }
  reply.out() << _tntChunks[162]; // </td>\n                
#line 560 "pageelems.ecpp"
if (LiveFeatures<features::epgsearch>().Recent() && eventId != 0) { 
  reply.out() << _tntChunks[163]; // \t\t<td class="action 
#line 561 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[164]; // "><a href="searchresults.html\?searchplain=
#line 561 "pageelems.ecpp"
  reply.sout() << ( StringUrlEncode(title) );
  reply.out() << _tntChunks[165]; // "><img src="
#line 561 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[166]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 561 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq28;
#line 561 "pageelems.ecpp"
    _tnt_cq28.add( "text", (tr("Search for repeats.")));
#line 561 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq28);
    // &>
  }
  reply.out() << _tntChunks[167]; // ></img></a></td>\n                
#line 562 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[168]; // \t\t<td class="action 
#line 563 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[169]; // ">
#line 563 "pageelems.ecpp"
if ((duration == 0) || (elapsed > 0)) { 
  // <& pageelems.hls_channel ...
  { 
#line 563 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq29;
#line 563 "pageelems.ecpp"
    _tnt_cq29.add( "channelId", (channelId));
#line 563 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq29);
    // &>
  }
#line 563 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[170]; // </td>\n\t\t
#line 564 "pageelems.ecpp"
 if (LiveSetup().GetShowPlayMediaplayer() ) { 
  reply.out() << _tntChunks[171]; // \t\t<td class="action 
#line 565 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[172]; // ">
#line 565 "pageelems.ecpp"
if ((duration == 0) || (elapsed > 0)) { 
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 565 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq30;
#line 565 "pageelems.ecpp"
    _tnt_cq30.add( "channelId", (channelId));
#line 565 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq30);
    // &>
  }
#line 565 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[173]; // </td>\n\t\t
#line 566 "pageelems.ecpp"
 } if (LiveSetup().GetShowIMDb() ) { 
  reply.out() << _tntChunks[174]; // \t\t<td class="action 
#line 567 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[175]; // ">\n
#line 568 "pageelems.ecpp"

			if (eventId != 0) {

  reply.out() << _tntChunks[176]; // \t\t\t
  // <& pageelems.imdb_info_href ...
  { 
#line 571 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq31;
#line 571 "pageelems.ecpp"
    _tnt_cq31.add( "s_IMDB_ID", (s_IMDB_ID));
#line 571 "pageelems.ecpp"
    _tnt_cq31.add( "title", (title));
#line 571 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq31);
    // &>
  }
  reply.out() << _tntChunks[177]; // \n
#line 572 "pageelems.ecpp"

			}

  reply.out() << _tntChunks[178]; // \t\t</td>\n
#line 576 "pageelems.ecpp"

	} }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epg_tt_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::epg_tt_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string boxId = qparam.get< std::string >("boxId");
std::string caption = qparam.get< std::string >("caption");
std::string tools_comp = qparam.get< std::string >("tools_comp");
std::string time = qparam.get< std::string >("time");
std::string title = qparam.get< std::string >("title");
std::string short_descr = qparam.get< std::string >("short_descr");
std::string long_descr = qparam.get< std::string >("long_descr");
std::string filename = qparam.get< std::string >("filename");
std::string archived = qparam.get< std::string >("archived");
std::string epgImage = qparam.get< std::string >("epgImage");
uintptr_t ievent = qparam.get< uintptr_t >("ievent");
uintptr_t irecording = qparam.get< uintptr_t >("irecording");
int elapsed = qparam.get< int >("elapsed", ( -1));
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[181]; // \t<div class="epg_description" id="
#line 599 "pageelems.ecpp"
  reply.sout() << ( (boxId) );
  reply.out() << _tntChunks[182]; // ">\n\t\t<div class="station">\n\t\t\t<div class="boxheader">\n\n<div>\n
#line 604 "pageelems.ecpp"

cScraperMovieOrTv scraperMovieOrTv;
scraperMovieOrTv.found = false;
scraperMovieOrTv.event = static_cast<cEvent *>((void *)ievent);
scraperMovieOrTv.recording = static_cast<cRecording *>((void *)irecording);
scraperMovieOrTv.httpImagePaths = false;
scraperMovieOrTv.media = true;
ScraperCallService("GetScraperMovieOrTv", &scraperMovieOrTv);
const bool episodeFound = scraperMovieOrTv.found && (!scraperMovieOrTv.movie) && scraperMovieOrTv.episodeFound;
if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[183]; // <div class = "caption menu">\n  <a id="
#line 616 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[184]; // _epg_m"     class = "active"   onclick="displayEPG('
#line 616 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[185]; // ')" >
#line 616 "pageelems.ecpp"
  reply.sout() << ( trVDR("EPG") );
  reply.out() << _tntChunks[186]; // </a>\n| <a id="
#line 617 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[187]; // _scraper_m" class = "inactive" onclick="displayScraper('
#line 617 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[188]; // ')">
#line 617 "pageelems.ecpp"
  reply.sout() << ( tr("Scraper") );
  reply.out() << _tntChunks[189]; // </a>\n| <a id="
#line 618 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[190]; // _actors_m"  class = "inactive" onclick="displayActors('
#line 618 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[191]; // ')" >
#line 618 "pageelems.ecpp"
  reply.sout() << ( tr("Actors") );
  reply.out() << _tntChunks[192]; // </a>\n| <a id="
#line 619 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[193]; // _artwork_m" class = "inactive" onclick="displayArtwork('
#line 619 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[194]; // ')" >
#line 619 "pageelems.ecpp"
  reply.sout() << ( tr("Artwork") );
  reply.out() << _tntChunks[195]; // </a>\n</div>\n
#line 621 "pageelems.ecpp"

} else {

  reply.out() << _tntChunks[196]; // <div class="caption">
#line 624 "pageelems.ecpp"
  reply.sout() << ( (caption) );
  reply.out() << _tntChunks[197]; // </div>\n
#line 625 "pageelems.ecpp"

}

  reply.out() << _tntChunks[198]; // </div>\n                        </div>\n\t\t</div>\n\t\t<div class="epg_content">\n\t\t\t<div class="epg_tools">\n\t\t\t\t
  // <& (tools_comp) ...
  { 
#line 633 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq32;
#line 633 "pageelems.ecpp"
    _tnt_cq32.add( "archived", (archived));
#line 633 "pageelems.ecpp"
    _tnt_cq32.add( "detail", (1));
#line 633 "pageelems.ecpp"
    _tnt_cq32.add( "id", (boxId));
#line 633 "pageelems.ecpp"
    _tnt_cq32.add( "s_IMDB_ID", (scraperMovieOrTv.IMDB_ID));
#line 633 "pageelems.ecpp"
    _tnt_cq32.add( "title", (title));
#line 633 "pageelems.ecpp"
    callComp((tools_comp), request, reply, _tnt_cq32);
    // &>
  }
  reply.out() << _tntChunks[199]; // \n\t\t\t</div>\n\t\t\t<div class="epg_info">\n\t\t\t\t<div class="info nowrap">
#line 636 "pageelems.ecpp"
 if (!archived.empty()) { 
  reply.out() << _tntChunks[200]; // <span class="bold">
#line 636 "pageelems.ecpp"
  reply.sout() << ( (archived + " ") );
  reply.out() << _tntChunks[201]; // </span>
#line 636 "pageelems.ecpp"
 } 
#line 636 "pageelems.ecpp"
  reply.sout() << ( (time) );
  reply.out() << _tntChunks[202]; // </div>\n
#line 637 "pageelems.ecpp"

	if (elapsed >= 0) {

  reply.out() << _tntChunks[203]; // \t\t\t\t<div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 640 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq33;
#line 640 "pageelems.ecpp"
    _tnt_cq33.add( "progress", (elapsed));
#line 640 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq33);
    // &>
  }
  reply.out() << _tntChunks[204]; // </div></div>\n
#line 641 "pageelems.ecpp"

	}

  reply.out() << _tntChunks[205]; // \t\t\t\t<div class="title">
#line 644 "pageelems.ecpp"
  reply.sout() << ( (title) );
  reply.out() << _tntChunks[206]; // </div>\n\t\t\t\t<div class="short">
#line 645 "pageelems.ecpp"
  reply.sout() << ( (short_descr) );
  reply.out() << _tntChunks[207]; // </div>\n\t\t\t\t<div class="description" id=
#line 646 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[208]; // _description>\n\t\t\t\t\t<span id = "
#line 647 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[209]; // _epg_image" class="epg_images">\n
#line 648 "pageelems.ecpp"

	std::list<std::string> images = EpgEvents::EpgImages(boxId);
	for(std::list<std::string>::iterator it = images.begin(); it != images.end(); ++it ) {

  reply.out() << _tntChunks[210]; //          <a href="/epgimages/
#line 652 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[211]; // " target="_blank">\n\t\t\t\t\t\t<img src="/epgimages/
#line 653 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[212]; // " class="epg_image"/>\n         </a>\n
#line 655 "pageelems.ecpp"

	}
        if(!epgImage.empty() ) {

  reply.out() << _tntChunks[213]; //          <a href="/tvscraper/
#line 659 "pageelems.ecpp"
  reply.sout() << ( epgImage );
  reply.out() << _tntChunks[214]; // " target="_blank">\n\t   <img src="/tvscraper/
#line 660 "pageelems.ecpp"
  reply.sout() << ( epgImage );
  reply.out() << _tntChunks[215]; // " class="epg_image"/>\n         </a>\n
#line 662 "pageelems.ecpp"

          if (episodeFound && !scraperMovieOrTv.episode.episodeImage.path.empty() ) {

  reply.out() << _tntChunks[216]; //            <a href="/tvscraper/
#line 665 "pageelems.ecpp"
  reply.sout() << ( ScraperImagePath2Live(scraperMovieOrTv.episode.episodeImage.path) );
  reply.out() << _tntChunks[217]; // " target="_blank">\n             <img src="/tvscraper/
#line 666 "pageelems.ecpp"
  reply.sout() << ( ScraperImagePath2Live(scraperMovieOrTv.episode.episodeImage.path) );
  reply.out() << _tntChunks[218]; // " class="epg_image"/>\n           </a>\n
#line 668 "pageelems.ecpp"

          }
	} else {

	std::list<std::string> images1 = EpgEvents::RecImages(boxId, filename);
	size_t delimPos = boxId.find_last_of('_');
	std::string recId = (delimPos)?boxId.substr(delimPos+1):boxId;

	for(std::list<std::string>::iterator it = images1.begin(); it != images1.end(); ++it ) {

  reply.out() << _tntChunks[219]; //          <a href="/recimages/
#line 678 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[220]; // /
#line 678 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[221]; // " target="_blank">\n\t\t\t\t\t\t<img src="/recimages/
#line 679 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[222]; // /
#line 679 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[223]; // " class="epg_image"/>\n         </a>\n
#line 681 "pageelems.ecpp"

	}}

  reply.out() << _tntChunks[224]; // \t\t\t\t\t</span>\n
  reply.out() << _tntChunks[225]; // \n<div id = '
#line 686 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[226]; // _scraper' hidden>\n
#line 687 "pageelems.ecpp"

if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[227]; // \n  <div class="short">
#line 693 "pageelems.ecpp"
  reply.sout() << ( tr("Title:") );
  reply.out() << _tntChunks[228]; //          
#line 693 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.title ) );
  reply.out() << _tntChunks[229]; // </div>\n
#line 694 "pageelems.ecpp"

  if (!scraperMovieOrTv.originalTitle.empty() ) {

  reply.out() << _tntChunks[230]; //   <div class="short">
#line 697 "pageelems.ecpp"
  reply.sout() << ( tr("Original title:") );
  reply.out() << _tntChunks[231]; //  
#line 697 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.originalTitle ) );
  reply.out() << _tntChunks[232]; // </div>\n
#line 698 "pageelems.ecpp"

  }
  if (episodeFound) {

  reply.out() << _tntChunks[233]; //     <div class="short">
#line 702 "pageelems.ecpp"
  reply.sout() << ( tr("Episode:") );
  reply.out() << _tntChunks[234]; //  S
#line 702 "pageelems.ecpp"
  reply.sout() << ( std::to_string(scraperMovieOrTv.episode.season ) );
  reply.out() << _tntChunks[235]; // E
#line 702 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.number ) );
#line 702 "pageelems.ecpp"
  reply.sout() << (scraperMovieOrTv.episode.absoluteNumber?"A" + std::to_string(scraperMovieOrTv.episode.absoluteNumber):"");
  reply.out() << _tntChunks[236]; //  
#line 702 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.name ) );
  reply.out() << _tntChunks[237]; // </div>\n    <div class="short">
#line 703 "pageelems.ecpp"
  reply.sout() << ( tr("Episode overview:") );
  reply.out() << _tntChunks[238]; //    
#line 703 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.overview ) );
  reply.out() << _tntChunks[239]; // </div>\n
#line 704 "pageelems.ecpp"

    if (scraperMovieOrTv.episode.vote_average != 0 ) {

  reply.out() << _tntChunks[240]; //       <div class="short">
#line 707 "pageelems.ecpp"
  reply.sout() << ( tr("Episode vote average/count:") );
  reply.out() << _tntChunks[241]; //  
#line 707 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.vote_average ) );
  reply.out() << _tntChunks[242]; //  / 
#line 707 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.vote_count ) );
  reply.out() << _tntChunks[243]; // </div>\n
#line 708 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[244]; //     <div class="short">
#line 711 "pageelems.ecpp"
  reply.sout() << ( tr("Episode first aired:") );
  reply.out() << _tntChunks[245]; //  
#line 711 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.firstAired ) );
  reply.out() << _tntChunks[246]; // </div>\n
#line 712 "pageelems.ecpp"

    if (!scraperMovieOrTv.episode.guestStars.empty() ) {

  reply.out() << _tntChunks[247]; //       <div class="short">
#line 715 "pageelems.ecpp"
  reply.sout() << ( tr("Episode guest stars:") );
#line 715 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.episode.guestStars) );
  reply.out() << _tntChunks[248]; // </div>\n
#line 716 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[249]; // \n
#line 722 "pageelems.ecpp"

    if (!scraperMovieOrTv.episode.director.empty() ) {

  reply.out() << _tntChunks[250]; //       <div class="short">
#line 725 "pageelems.ecpp"
  reply.sout() << ( tr("Episode director:") );
  reply.out() << _tntChunks[251]; //    
#line 725 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.episode.director) );
  reply.out() << _tntChunks[252]; // </div>\n
#line 726 "pageelems.ecpp"

    }
    if (!scraperMovieOrTv.episode.writer.empty() ) {

  reply.out() << _tntChunks[253]; //       <div class="short">
#line 730 "pageelems.ecpp"
  reply.sout() << ( tr("Episode writer:") );
  reply.out() << _tntChunks[254]; //      
#line 730 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.episode.writer) );
  reply.out() << _tntChunks[255]; // </div>\n
#line 731 "pageelems.ecpp"

    }
    if (!scraperMovieOrTv.episode.IMDB_ID.empty() ) {

  reply.out() << _tntChunks[256]; //       <a href="https://www.imdb.com/title/
#line 735 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.IMDB_ID ) );
  reply.out() << _tntChunks[257]; // " target="_blank"> 
#line 735 "pageelems.ecpp"
  reply.sout() << ( tr("IMDB episode") );
  reply.out() << _tntChunks[258]; //  </a>\n
#line 736 "pageelems.ecpp"

    }
  }  // end if episode found
  if (!scraperMovieOrTv.tagline.empty() ) {

  reply.out() << _tntChunks[259]; //   <div class="short">
#line 741 "pageelems.ecpp"
  reply.sout() << ( tr("Tagline:") );
  reply.out() << _tntChunks[260]; //         
#line 741 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.tagline ) );
  reply.out() << _tntChunks[261]; // </div>\n
#line 742 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[262]; //   <div class="short">
#line 745 "pageelems.ecpp"
  reply.sout() << ( tr("Overview:") );
  reply.out() << _tntChunks[263]; //        
#line 745 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.overview ) );
  reply.out() << _tntChunks[264]; // </div>\n  <div class="short">
#line 746 "pageelems.ecpp"
  reply.sout() << ( tr("Genres:") );
  reply.out() << _tntChunks[265]; //          
#line 746 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.genres ) );
  reply.out() << _tntChunks[266]; // </div>\n
#line 747 "pageelems.ecpp"

  if (!scraperMovieOrTv.homepage.empty() ) {

  reply.out() << _tntChunks[267]; //   <div class="short"><a href ="
#line 750 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.homepage) );
  reply.out() << _tntChunks[268]; // " target="_blank">
#line 750 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[269]; // </a></div>\n
#line 751 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[270]; //   <div class="short">
#line 754 "pageelems.ecpp"
  reply.sout() << ( tr("Release date:") );
  reply.out() << _tntChunks[271]; //    
#line 754 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.releaseDate ) );
  reply.out() << _tntChunks[272]; // </div>\n  <div class="short">
#line 755 "pageelems.ecpp"
  reply.sout() << ( tr("Runtimes:") );
  reply.out() << _tntChunks[273]; //        
#line 755 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.runtimes ) );
  reply.out() << _tntChunks[274]; // </div>\n
#line 756 "pageelems.ecpp"

  if (scraperMovieOrTv.popularity != 0) {

  reply.out() << _tntChunks[275]; //   <div class="short">
#line 759 "pageelems.ecpp"
  reply.sout() << ( tr("Popularity:") );
  reply.out() << _tntChunks[276]; //      
#line 759 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.popularity ) );
  reply.out() << _tntChunks[277]; // </div>\n
#line 760 "pageelems.ecpp"

  }
  if (scraperMovieOrTv.voteAverage  != 0) {

  reply.out() << _tntChunks[278]; //   <div class="short">
#line 764 "pageelems.ecpp"
  reply.sout() << ( tr("Vote average/count:") );
  reply.out() << _tntChunks[279]; //  
#line 764 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.voteAverage ) );
  reply.out() << _tntChunks[280]; //  / 
#line 764 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.voteCount ) );
  reply.out() << _tntChunks[281]; // </div>\n
#line 765 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[282]; // \n
#line 771 "pageelems.ecpp"

  if (!scraperMovieOrTv.actors.empty() ) {

  reply.out() << _tntChunks[283]; //   <div class="short">
#line 774 "pageelems.ecpp"
  reply.sout() << ( tr("Actors:") );
  reply.out() << _tntChunks[284]; //          
#line 774 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.actors) );
  reply.out() << _tntChunks[285]; // </div>\n
#line 775 "pageelems.ecpp"

  }
  if (!scraperMovieOrTv.IMDB_ID.empty() ) {

  reply.out() << _tntChunks[286]; //     <a href="https://www.imdb.com/title/
#line 779 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.IMDB_ID ) );
  reply.out() << _tntChunks[287]; // " target="_blank"> 
#line 779 "pageelems.ecpp"
  reply.sout() << ( tr("IMDB") );
  reply.out() << _tntChunks[288]; //  </a>\n
#line 780 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[289]; // \n
#line 787 "pageelems.ecpp"

  if (scraperMovieOrTv.movie) {
    if (scraperMovieOrTv.budget) {

  reply.out() << _tntChunks[290]; //     <div class="short">
#line 791 "pageelems.ecpp"
  reply.sout() << ( tr("Budget:") );
  reply.out() << _tntChunks[291]; //          
#line 791 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.budget ) );
  reply.out() << _tntChunks[292]; // </div>\n
#line 792 "pageelems.ecpp"

    }
    if (scraperMovieOrTv.revenue) {

  reply.out() << _tntChunks[293]; //     <div class="short">
#line 796 "pageelems.ecpp"
  reply.sout() << ( tr("Revenue:") );
  reply.out() << _tntChunks[294]; //         
#line 796 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.revenue) );
  reply.out() << _tntChunks[295]; // </div>\n
#line 797 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[296]; // \n
#line 803 "pageelems.ecpp"

    if (!scraperMovieOrTv.collectionName.empty() ) {

  reply.out() << _tntChunks[297]; //     <div class="short">
#line 806 "pageelems.ecpp"
  reply.sout() << ( tr("Collection name:") );
  reply.out() << _tntChunks[298]; //  
#line 806 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.collectionName) );
  reply.out() << _tntChunks[299]; // </div>\n
#line 807 "pageelems.ecpp"

    }
    if (!scraperMovieOrTv.director.empty() ) {

  reply.out() << _tntChunks[300]; //     <div class="short">
#line 811 "pageelems.ecpp"
  reply.sout() << ( tr("Director:") );
  reply.out() << _tntChunks[301]; //        
#line 811 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.director) );
  reply.out() << _tntChunks[302]; // </div>\n
#line 812 "pageelems.ecpp"

    }
    if (!scraperMovieOrTv.writer.empty() ) {

  reply.out() << _tntChunks[303]; //     <div class="short">
#line 816 "pageelems.ecpp"
  reply.sout() << ( tr("Writer:") );
  reply.out() << _tntChunks[304]; //          
#line 816 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.writer) );
  reply.out() << _tntChunks[305]; // </div>\n
#line 817 "pageelems.ecpp"

    }
  } else {  // TV show

  reply.out() << _tntChunks[306]; //     <div class="short">
#line 821 "pageelems.ecpp"
  reply.sout() << ( tr("Status:") );
  reply.out() << _tntChunks[307]; //          
#line 821 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.status    ) );
  reply.out() << _tntChunks[308]; // </div>\n
  reply.out() << _tntChunks[309]; // \n
#line 825 "pageelems.ecpp"

    if (!scraperMovieOrTv.createdBy.empty() ) {

  reply.out() << _tntChunks[310]; //       <div class="short">
#line 828 "pageelems.ecpp"
  reply.sout() << ( tr("Created by:") );
  reply.out() << _tntChunks[311]; //      
#line 828 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.createdBy) );
  reply.out() << _tntChunks[312]; // </div>\n
#line 829 "pageelems.ecpp"

    }
  }
}

  reply.out() << _tntChunks[313]; // </div>\n
  reply.out() << _tntChunks[314]; // \n<div id = '
#line 836 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[315]; // _actors' hidden>\n
#line 837 "pageelems.ecpp"

if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[316]; // <table>\n
#line 841 "pageelems.ecpp"

  const int num_cols = 4;
  int num = 1;
  std::string actor_names = "";
  for (cActor &actor: scraperMovieOrTv.actors) {
    if (actor.actorThumb.path.empty() ) continue;  // only actors with images
    if (num == 1) {

  reply.out() << _tntChunks[317]; //       <tr>\n
#line 850 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[318]; //     <td>\n      <a href="/tvscraper/
#line 854 "pageelems.ecpp"
  reply.sout() << ( ScraperImagePath2Live(actor.actorThumb.path) );
  reply.out() << _tntChunks[319]; // " target="_blank">\n        <img src="/tvscraper/
#line 855 "pageelems.ecpp"
  reply.sout() << ( ScraperImagePath2Live(actor.actorThumb.path) );
  reply.out() << _tntChunks[320]; // " alt="
#line 855 "pageelems.ecpp"
  reply.sout() << (actor.name);
  reply.out() << _tntChunks[321]; // : 
#line 855 "pageelems.ecpp"
  reply.sout() << (actor.role);
  reply.out() << _tntChunks[322]; // " class="actor">\n        </img>\n      </a>\n    </td>\n
#line 859 "pageelems.ecpp"

    actor_names.append("<td>"); 
    actor_names.append(actor.name); 
    actor_names.append(":<br>"); 
    actor_names.append(actor.role); 
    actor_names.append("</td>"); 
    if (num == num_cols) {

  reply.out() << _tntChunks[323]; //       </tr>\n      <tr>
#line 868 "pageelems.ecpp"
  reply.out() << (actor_names);
  reply.out() << _tntChunks[324]; // </tr>\n
#line 869 "pageelems.ecpp"

      num = 0;
      actor_names = "";
    }
    num++;
  } // for actor in actors
  if (episodeFound) for (cActor &actor: scraperMovieOrTv.episode.guestStars) {
    if (actor.actorThumb.path.empty() ) continue;  // only actors with images
    if (num == 1) {

  reply.out() << _tntChunks[325]; //       <tr>\n
#line 880 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[326]; //     <td>\n      <a href="/tvscraper/
#line 884 "pageelems.ecpp"
  reply.sout() << ( ScraperImagePath2Live(actor.actorThumb.path) );
  reply.out() << _tntChunks[327]; // " target="_blank">\n        <img src="/tvscraper/
#line 885 "pageelems.ecpp"
  reply.sout() << ( ScraperImagePath2Live(actor.actorThumb.path) );
  reply.out() << _tntChunks[328]; // " alt="
#line 885 "pageelems.ecpp"
  reply.sout() << (actor.name);
  reply.out() << _tntChunks[329]; // : 
#line 885 "pageelems.ecpp"
  reply.sout() << (actor.role);
  reply.out() << _tntChunks[330]; // " class="actor">\n        </img>\n      </a>\n    </td>\n
#line 889 "pageelems.ecpp"

    actor_names.append("<td>"); 
    actor_names.append(actor.name); 
    actor_names.append(":<br>"); 
    actor_names.append(actor.role); 
    actor_names.append("</td>"); 
    if (num == num_cols) {

  reply.out() << _tntChunks[331]; //       </tr>\n      <tr>
#line 898 "pageelems.ecpp"
  reply.out() << (actor_names);
  reply.out() << _tntChunks[332]; // </tr>\n
#line 899 "pageelems.ecpp"

      num = 0;
    }
    num++;
  } // for actor in episode.guestStars
  if (num != 1) {

  reply.out() << _tntChunks[333]; //     </tr>\n    <tr>
#line 907 "pageelems.ecpp"
  reply.out() << (actor_names);
  reply.out() << _tntChunks[334]; // </tr>\n
#line 908 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[335]; // </table>\n
#line 912 "pageelems.ecpp"

}

  reply.out() << _tntChunks[336]; // </div>\n
  reply.out() << _tntChunks[337]; // \n<div id = '
#line 917 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[338]; // _artwork' hidden>\n
#line 918 "pageelems.ecpp"

  const uintptr_t media_p = (uintptr_t)&(scraperMovieOrTv.posters);
  const uintptr_t media_b = (uintptr_t)&(scraperMovieOrTv.banners);
  const uintptr_t media_f = (uintptr_t)&(scraperMovieOrTv.fanarts);

  // <& media ...
  { 
#line 923 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq34;
#line 923 "pageelems.ecpp"
    _tnt_cq34.add( "media_p", (media_p));
#line 923 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq34);
    // &>
  }
  reply.out() << _tntChunks[339]; // \n
  // <& media ...
  { 
#line 924 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq35;
#line 924 "pageelems.ecpp"
    _tnt_cq35.add( "media_p", (media_f));
#line 924 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq35);
    // &>
  }
  reply.out() << _tntChunks[340]; // \n
  // <& media ...
  { 
#line 925 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq36;
#line 925 "pageelems.ecpp"
    _tnt_cq36.add( "media_p", (media_b));
#line 925 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq36);
    // &>
  }
  reply.out() << _tntChunks[341]; // \n</div>\n
  reply.out() << _tntChunks[342]; // \n<div id = '
#line 928 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[343]; // _epg'>\n\t\t\t\t\t
#line 929 "pageelems.ecpp"
 reply.out() << StringEscapeAndBreak(long_descr); 
  reply.out() << _tntChunks[344]; // \t\t\t\t</div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::media_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::media " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
uintptr_t media_p = qparam.get< uintptr_t >("media_p");
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 942 "pageelems.ecpp"

const std::vector<cTvMedia> *media_v = static_cast<std::vector<cTvMedia> *>((void *)media_p);
for (const cTvMedia &media: *media_v) {

  reply.out() << _tntChunks[347]; //   <a href="/tvscraper/
#line 946 "pageelems.ecpp"
  reply.sout() << ( ScraperImagePath2Live(media.path) );
  reply.out() << _tntChunks[348]; // " target="_blank">\n    <img src="/tvscraper/
#line 947 "pageelems.ecpp"
  reply.sout() << ( ScraperImagePath2Live(media.path) );
  reply.out() << _tntChunks[349]; // " class="artwork">\n    </img>\n  </a>\n
#line 950 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::about_tt_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::about_tt_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[351]; // \t<div class="epg_description" id="aboutBox">\n\t\t<div class="station">\n\t\t\t<div class="boxheader"><div><div class="caption">
#line 959 "pageelems.ecpp"
  reply.sout() << ( tr(LIVESUMMARY) );
  reply.out() << _tntChunks[352]; // </div></div></div>\n\t\t</div>\n\t\t<div class="epg_content">\n\t\t\t<div>\n\t\t\t\t<div class="about_head"><div><div>
#line 963 "pageelems.ecpp"
  reply.sout() << ( tr("Authors") );
  reply.out() << _tntChunks[353]; // </div></div></div>\n\t\t\t\t<div class="about_left">
#line 964 "pageelems.ecpp"
  reply.sout() << ( tr("Project Idea") );
  reply.out() << _tntChunks[354]; // :</div>\n\t\t\t\t<div class="about_right">Thomas Keil (Thomas)</div>\n\t\t\t\t<div class="about_left">
#line 966 "pageelems.ecpp"
  reply.sout() << ( tr("Webserver") );
  reply.out() << _tntChunks[355]; // :</div>\n\t\t\t\t<div class="about_right">Sascha Volkenandt (LordJaxom)</div>\n\t\t\t\t<div class="about_left">
#line 968 "pageelems.ecpp"
  reply.sout() << ( tr("Current Maintainer") );
  reply.out() << _tntChunks[356]; // :</div>\n\t\t\t\t<div class="about_right">Markus Ehrnsperger (MarkusE @ <a href="https://www.vdr-portal.de">VDR Portal</a>)</div>\n\t\t\t\t<div class="about_left">
#line 970 "pageelems.ecpp"
  reply.sout() << ( tr("Previous Maintainer") );
  reply.out() << _tntChunks[357]; // :</div>\n\t\t\t\t<div class="about_right">Jasmin Jessich (jasminj)</div>\n\t\t\t\t<div class="about_left">
#line 972 "pageelems.ecpp"
  reply.sout() << ( tr("Project leader") );
  reply.out() << _tntChunks[358]; // :</div>\n\t\t\t\t<div class="about_right">Dieter Hametner (tadi)</div>\n\t\t\t\t<div class="about_left">
#line 974 "pageelems.ecpp"
  reply.sout() << ( tr("Content") );
  reply.out() << _tntChunks[359]; // :</div>\n\t\t\t\t<div class="about_right">Christian Wieninger (winni)</div>\n\t\t\t\t<div class="about_left">
#line 976 "pageelems.ecpp"
  reply.sout() << ( tr("Graphics") );
  reply.out() << _tntChunks[360]; // :</div>\n\t\t\t\t<div class="about_right">Michael Br&uuml;ckner (skiller2k1)</div>\n\t\t\t\t<div class="about_head"><div><div>
#line 978 "pageelems.ecpp"
  reply.sout() << ( tr("Information") );
  reply.out() << _tntChunks[361]; // </div></div></div>\n\t\t\t\t<div class="about_left">
#line 979 "pageelems.ecpp"
  reply.sout() << ( tr("LIVE version") );
  reply.out() << _tntChunks[362]; // :</div>\n\t\t\t\t<div class="about_right">
#line 980 "pageelems.ecpp"
  reply.sout() << ( LIVEVERSION );
#line 980 "pageelems.ecpp"
  reply.sout() << ( VERSION_SUFFIX );
  reply.out() << _tntChunks[363]; // </div>\n\t\t\t\t<div class="about_left">
#line 981 "pageelems.ecpp"
  reply.sout() << ( tr("VDR version") );
  reply.out() << _tntChunks[364]; // :</div>\n\t\t\t\t<div class="about_right">
#line 982 "pageelems.ecpp"
  reply.sout() << ( VDRVERSION );
  reply.out() << _tntChunks[365]; // </div>\n\t\t\t\t<div class="about_head"><div><div>
#line 983 "pageelems.ecpp"
  reply.sout() << ( tr("Features") );
  reply.out() << _tntChunks[366]; // </div></div></div>\n\t\t\t\t<div class="about_left">EPGsearch:</div>\n\t\t\t\t<div class="about_right">\n
#line 986 "pageelems.ecpp"

					Features< features::epgsearch >& epgsearch = LiveFeatures< features::epgsearch >();

  reply.out() << _tntChunks[367]; // \t\t\t\t\t<img align="center" src="
#line 989 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", epgsearch.Recent() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[368]; // "/>\n
#line 990 "pageelems.ecpp"

					if ( epgsearch.Recent() ) {

  reply.out() << _tntChunks[369]; // \t\t\t\t\t\t
#line 993 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[370]; // : 
#line 993 "pageelems.ecpp"
  reply.sout() << ( epgsearch.Version() );
  reply.out() << _tntChunks[371]; // \n
#line 994 "pageelems.ecpp"

					} else {

  reply.out() << _tntChunks[372]; // \t\t\t\t\t\t
#line 997 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[373]; // : 
#line 997 "pageelems.ecpp"
  reply.sout() << ( epgsearch.MinVersion() );
  reply.out() << _tntChunks[374]; // \n
#line 998 "pageelems.ecpp"

					}

  reply.out() << _tntChunks[375]; // \t\t\t\t\t(<a href="https://github.com/vdr-projects/vdr-plugin-epgsearch" target="_blank">
#line 1001 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[376]; // </a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class="about_left">Streamdev server:</div>\n\t\t\t\t<div class="about_right">\n
#line 1005 "pageelems.ecpp"

					Features< features::streamdev_server >& streamdev = LiveFeatures< features::streamdev_server >();

  reply.out() << _tntChunks[377]; // \t\t\t\t\t<img align="center" src="
#line 1008 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", streamdev.Loaded() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[378]; // "/>\n
#line 1009 "pageelems.ecpp"

					if ( streamdev.Loaded() ) {

  reply.out() << _tntChunks[379]; // \t\t\t\t\t\t
#line 1012 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[380]; // : 
#line 1012 "pageelems.ecpp"
  reply.sout() << ( streamdev.Version() );
  reply.out() << _tntChunks[381]; // \n
#line 1013 "pageelems.ecpp"

					} else {

  reply.out() << _tntChunks[382]; // \t\t\t\t\t\t
#line 1016 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[383]; // : 
#line 1016 "pageelems.ecpp"
  reply.sout() << ( streamdev.MinVersion() );
  reply.out() << _tntChunks[384]; // \n
#line 1017 "pageelems.ecpp"

					}

  reply.out() << _tntChunks[385]; // \t\t\t\t\t(<a href="https://github.com/vdr-projects/vdr-plugin-streamdev" target="_blank">
#line 1020 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[386]; // </a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1022 "pageelems.ecpp"
  reply.sout() << ( tr("Information providers") );
  reply.out() << _tntChunks[387]; // </div></div></div>\n\t\t\t\t<div class="about_line">Movie information provided by <a target="_blank" href="https://www.themoviedb.org/">TMDB</a></div>\n\t\t\t\t<div class="about_line">Information provided by TheTVDB.com. Please consider <a target="_blank" href="https://u10505776.ct.sendgrid.net/ls/click\?upn=xMYYCP13hVd-2BZPpbVcMPHeLXfv-2BPRdIsKm2qSeirIHi7kH9am8IxD-2BavFbeqGqIXIcjH_INgc0CXRkIvGU-2BJ1W6HLAynNbR0UBoMb2tkpDdezO3QRj-2FQPQAMrtJKVcB0N7eSvbYpjQTDNOQBf2pb94uDgGr0-2BXyXFk7Oyfva30BASYCRLvtRQyi5eOCAbH8fon7UETlPydobeLA3Recu9OsXol8c7Ng4pDAsH6KsFF8CH7HQoVxivnpKrQW2v4ek7U-2BYlWmH31o9Koke3vq-2FDsQ0P-2BiKLECU3LgttsntUcN8fnUs-3D">supporting them</a></div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1025 "pageelems.ecpp"
  reply.sout() << ( tr("Bugs and suggestions") );
  reply.out() << _tntChunks[388]; // </div></div></div>\n\t\t\t\t<div class="about_line">
#line 1026 "pageelems.ecpp"
  reply.sout() << ( tr("If you encounter any bugs or would like to suggest new features, please use our bugtracker") );
  reply.out() << _tntChunks[389]; // :<br/>\n\t\t\t\t\t<a target="_blank" href="https://github.com/MarkusEh/vdr-plugin-live/issues">https://github.com/MarkusEh/vdr-plugin-live/issues</a></div>\n\t\t\t\t<div class="about_head"><div><div>&nbsp;</div></div></div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
